<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfAdvancedLogic ArrayType
 * @subpackage Arrays
 */
class ArrayOfAdvancedLogic extends AbstractStructArrayBase
{
    /**
     * The AdvancedLogic
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\AdvancedLogic[]
     */
    public $AdvancedLogic;
    /**
     * Constructor method for ArrayOfAdvancedLogic
     * @uses ArrayOfAdvancedLogic::setAdvancedLogic()
     * @param \StructType\AdvancedLogic[] $advancedLogic
     */
    public function __construct(array $advancedLogic = array())
    {
        $this
            ->setAdvancedLogic($advancedLogic);
    }
    /**
     * Get AdvancedLogic value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\AdvancedLogic[]|null
     */
    public function getAdvancedLogic()
    {
        return isset($this->AdvancedLogic) ? $this->AdvancedLogic : null;
    }
    /**
     * This method is responsible for validating the values passed to the setAdvancedLogic method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdvancedLogic method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdvancedLogicForArrayConstraintsFromSetAdvancedLogic(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfAdvancedLogicAdvancedLogicItem) {
            // validation for constraint: itemType
            if (!$arrayOfAdvancedLogicAdvancedLogicItem instanceof \StructType\AdvancedLogic) {
                $invalidValues[] = is_object($arrayOfAdvancedLogicAdvancedLogicItem) ? get_class($arrayOfAdvancedLogicAdvancedLogicItem) : sprintf('%s(%s)', gettype($arrayOfAdvancedLogicAdvancedLogicItem), var_export($arrayOfAdvancedLogicAdvancedLogicItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdvancedLogic property can only contain items of type \StructType\AdvancedLogic, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdvancedLogic value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\AdvancedLogic[] $advancedLogic
     * @return \ArrayType\ArrayOfAdvancedLogic
     */
    public function setAdvancedLogic(array $advancedLogic = array())
    {
        // validation for constraint: array
        if ('' !== ($advancedLogicArrayErrorMessage = self::validateAdvancedLogicForArrayConstraintsFromSetAdvancedLogic($advancedLogic))) {
            throw new \InvalidArgumentException($advancedLogicArrayErrorMessage, __LINE__);
        }
        if (is_null($advancedLogic) || (is_array($advancedLogic) && empty($advancedLogic))) {
            unset($this->AdvancedLogic);
        } else {
            $this->AdvancedLogic = $advancedLogic;
        }
        return $this;
    }
    /**
     * Add item to AdvancedLogic value
     * @throws \InvalidArgumentException
     * @param \StructType\AdvancedLogic $item
     * @return \ArrayType\ArrayOfAdvancedLogic
     */
    public function addToAdvancedLogic(\StructType\AdvancedLogic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AdvancedLogic) {
            throw new \InvalidArgumentException(sprintf('The AdvancedLogic property can only contain items of type \StructType\AdvancedLogic, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdvancedLogic[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\AdvancedLogic|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\AdvancedLogic|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\AdvancedLogic|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\AdvancedLogic|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\AdvancedLogic|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string AdvancedLogic
     */
    public function getAttributeName()
    {
        return 'AdvancedLogic';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfAdvancedLogic
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
