<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCvConversionRate ArrayType
 * @subpackage Arrays
 */
class ArrayOfCvConversionRate extends AbstractStructArrayBase
{
    /**
     * The CvConversionRate
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CvConversionRate[]
     */
    public $CvConversionRate;
    /**
     * Constructor method for ArrayOfCvConversionRate
     * @uses ArrayOfCvConversionRate::setCvConversionRate()
     * @param \StructType\CvConversionRate[] $cvConversionRate
     */
    public function __construct(array $cvConversionRate = array())
    {
        $this
            ->setCvConversionRate($cvConversionRate);
    }
    /**
     * Get CvConversionRate value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\CvConversionRate[]|null
     */
    public function getCvConversionRate()
    {
        return isset($this->CvConversionRate) ? $this->CvConversionRate : null;
    }
    /**
     * This method is responsible for validating the values passed to the setCvConversionRate method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCvConversionRate method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCvConversionRateForArrayConstraintsFromSetCvConversionRate(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCvConversionRateCvConversionRateItem) {
            // validation for constraint: itemType
            if (!$arrayOfCvConversionRateCvConversionRateItem instanceof \StructType\CvConversionRate) {
                $invalidValues[] = is_object($arrayOfCvConversionRateCvConversionRateItem) ? get_class($arrayOfCvConversionRateCvConversionRateItem) : sprintf('%s(%s)', gettype($arrayOfCvConversionRateCvConversionRateItem), var_export($arrayOfCvConversionRateCvConversionRateItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CvConversionRate property can only contain items of type \StructType\CvConversionRate, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CvConversionRate value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\CvConversionRate[] $cvConversionRate
     * @return \ArrayType\ArrayOfCvConversionRate
     */
    public function setCvConversionRate(array $cvConversionRate = array())
    {
        // validation for constraint: array
        if ('' !== ($cvConversionRateArrayErrorMessage = self::validateCvConversionRateForArrayConstraintsFromSetCvConversionRate($cvConversionRate))) {
            throw new \InvalidArgumentException($cvConversionRateArrayErrorMessage, __LINE__);
        }
        if (is_null($cvConversionRate) || (is_array($cvConversionRate) && empty($cvConversionRate))) {
            unset($this->CvConversionRate);
        } else {
            $this->CvConversionRate = $cvConversionRate;
        }
        return $this;
    }
    /**
     * Add item to CvConversionRate value
     * @throws \InvalidArgumentException
     * @param \StructType\CvConversionRate $item
     * @return \ArrayType\ArrayOfCvConversionRate
     */
    public function addToCvConversionRate(\StructType\CvConversionRate $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CvConversionRate) {
            throw new \InvalidArgumentException(sprintf('The CvConversionRate property can only contain items of type \StructType\CvConversionRate, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CvConversionRate[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CvConversionRate|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CvConversionRate|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CvConversionRate|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CvConversionRate|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CvConversionRate|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CvConversionRate
     */
    public function getAttributeName()
    {
        return 'CvConversionRate';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCvConversionRate
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
