<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfCvObject ArrayType
 * @subpackage Arrays
 */
class ArrayOfCvObject extends AbstractStructArrayBase
{
    /**
     * The CvObject
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\CvObject[]
     */
    public $CvObject;
    /**
     * Constructor method for ArrayOfCvObject
     * @uses ArrayOfCvObject::setCvObject()
     * @param \StructType\CvObject[] $cvObject
     */
    public function __construct(array $cvObject = array())
    {
        $this
            ->setCvObject($cvObject);
    }
    /**
     * Get CvObject value
     * @return \StructType\CvObject[]|null
     */
    public function getCvObject()
    {
        return $this->CvObject;
    }
    /**
     * This method is responsible for validating the values passed to the setCvObject method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCvObject method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCvObjectForArrayConstraintsFromSetCvObject(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfCvObjectCvObjectItem) {
            // validation for constraint: itemType
            if (!$arrayOfCvObjectCvObjectItem instanceof \StructType\CvObject) {
                $invalidValues[] = is_object($arrayOfCvObjectCvObjectItem) ? get_class($arrayOfCvObjectCvObjectItem) : sprintf('%s(%s)', gettype($arrayOfCvObjectCvObjectItem), var_export($arrayOfCvObjectCvObjectItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CvObject property can only contain items of type \StructType\CvObject, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CvObject value
     * @throws \InvalidArgumentException
     * @param \StructType\CvObject[] $cvObject
     * @return \ArrayType\ArrayOfCvObject
     */
    public function setCvObject(array $cvObject = array())
    {
        // validation for constraint: array
        if ('' !== ($cvObjectArrayErrorMessage = self::validateCvObjectForArrayConstraintsFromSetCvObject($cvObject))) {
            throw new \InvalidArgumentException($cvObjectArrayErrorMessage, __LINE__);
        }
        $this->CvObject = $cvObject;
        return $this;
    }
    /**
     * Add item to CvObject value
     * @throws \InvalidArgumentException
     * @param \StructType\CvObject $item
     * @return \ArrayType\ArrayOfCvObject
     */
    public function addToCvObject(\StructType\CvObject $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CvObject) {
            throw new \InvalidArgumentException(sprintf('The CvObject property can only contain items of type \StructType\CvObject, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CvObject[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CvObject|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CvObject|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CvObject|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CvObject|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CvObject|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CvObject
     */
    public function getAttributeName()
    {
        return 'CvObject';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfCvObject
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
