<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for CopyEventResultArray ArrayType
 * @subpackage Arrays
 */
class CopyEventResultArray extends AbstractStructArrayBase
{
    /**
     * The CopyEventResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CopyEventResult[]
     */
    public $CopyEventResult;
    /**
     * Constructor method for CopyEventResultArray
     * @uses CopyEventResultArray::setCopyEventResult()
     * @param \StructType\CopyEventResult[] $copyEventResult
     */
    public function __construct(array $copyEventResult = array())
    {
        $this
            ->setCopyEventResult($copyEventResult);
    }
    /**
     * Get CopyEventResult value
     * @return \StructType\CopyEventResult[]|null
     */
    public function getCopyEventResult()
    {
        return $this->CopyEventResult;
    }
    /**
     * This method is responsible for validating the values passed to the setCopyEventResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCopyEventResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCopyEventResultForArrayConstraintsFromSetCopyEventResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $copyEventResultArrayCopyEventResultItem) {
            // validation for constraint: itemType
            if (!$copyEventResultArrayCopyEventResultItem instanceof \StructType\CopyEventResult) {
                $invalidValues[] = is_object($copyEventResultArrayCopyEventResultItem) ? get_class($copyEventResultArrayCopyEventResultItem) : sprintf('%s(%s)', gettype($copyEventResultArrayCopyEventResultItem), var_export($copyEventResultArrayCopyEventResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CopyEventResult property can only contain items of type \StructType\CopyEventResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CopyEventResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CopyEventResult[] $copyEventResult
     * @return \ArrayType\CopyEventResultArray
     */
    public function setCopyEventResult(array $copyEventResult = array())
    {
        // validation for constraint: array
        if ('' !== ($copyEventResultArrayErrorMessage = self::validateCopyEventResultForArrayConstraintsFromSetCopyEventResult($copyEventResult))) {
            throw new \InvalidArgumentException($copyEventResultArrayErrorMessage, __LINE__);
        }
        $this->CopyEventResult = $copyEventResult;
        return $this;
    }
    /**
     * Add item to CopyEventResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CopyEventResult $item
     * @return \ArrayType\CopyEventResultArray
     */
    public function addToCopyEventResult(\StructType\CopyEventResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CopyEventResult) {
            throw new \InvalidArgumentException(sprintf('The CopyEventResult property can only contain items of type \StructType\CopyEventResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CopyEventResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CopyEventResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CopyEventResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CopyEventResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CopyEventResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CopyEventResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CopyEventResult
     */
    public function getAttributeName()
    {
        return 'CopyEventResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\CopyEventResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
