<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for CreateApproverResultArray ArrayType
 * @subpackage Arrays
 */
class CreateApproverResultArray extends AbstractStructArrayBase
{
    /**
     * The CreateApproverResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CreateApproverResult[]
     */
    public $CreateApproverResult;
    /**
     * Constructor method for CreateApproverResultArray
     * @uses CreateApproverResultArray::setCreateApproverResult()
     * @param \StructType\CreateApproverResult[] $createApproverResult
     */
    public function __construct(array $createApproverResult = array())
    {
        $this
            ->setCreateApproverResult($createApproverResult);
    }
    /**
     * Get CreateApproverResult value
     * @return \StructType\CreateApproverResult[]|null
     */
    public function getCreateApproverResult()
    {
        return $this->CreateApproverResult;
    }
    /**
     * This method is responsible for validating the values passed to the setCreateApproverResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCreateApproverResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCreateApproverResultForArrayConstraintsFromSetCreateApproverResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createApproverResultArrayCreateApproverResultItem) {
            // validation for constraint: itemType
            if (!$createApproverResultArrayCreateApproverResultItem instanceof \StructType\CreateApproverResult) {
                $invalidValues[] = is_object($createApproverResultArrayCreateApproverResultItem) ? get_class($createApproverResultArrayCreateApproverResultItem) : sprintf('%s(%s)', gettype($createApproverResultArrayCreateApproverResultItem), var_export($createApproverResultArrayCreateApproverResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CreateApproverResult property can only contain items of type \StructType\CreateApproverResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CreateApproverResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateApproverResult[] $createApproverResult
     * @return \ArrayType\CreateApproverResultArray
     */
    public function setCreateApproverResult(array $createApproverResult = array())
    {
        // validation for constraint: array
        if ('' !== ($createApproverResultArrayErrorMessage = self::validateCreateApproverResultForArrayConstraintsFromSetCreateApproverResult($createApproverResult))) {
            throw new \InvalidArgumentException($createApproverResultArrayErrorMessage, __LINE__);
        }
        $this->CreateApproverResult = $createApproverResult;
        return $this;
    }
    /**
     * Add item to CreateApproverResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateApproverResult $item
     * @return \ArrayType\CreateApproverResultArray
     */
    public function addToCreateApproverResult(\StructType\CreateApproverResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CreateApproverResult) {
            throw new \InvalidArgumentException(sprintf('The CreateApproverResult property can only contain items of type \StructType\CreateApproverResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CreateApproverResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CreateApproverResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CreateApproverResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CreateApproverResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CreateApproverResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CreateApproverResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CreateApproverResult
     */
    public function getAttributeName()
    {
        return 'CreateApproverResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\CreateApproverResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
