<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for CreateCustomFieldResultArray ArrayType
 * @subpackage Arrays
 */
class CreateCustomFieldResultArray extends AbstractStructArrayBase
{
    /**
     * The CreateCustomFieldResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CreateCustomFieldResult[]
     */
    public $CreateCustomFieldResult;
    /**
     * Constructor method for CreateCustomFieldResultArray
     * @uses CreateCustomFieldResultArray::setCreateCustomFieldResult()
     * @param \StructType\CreateCustomFieldResult[] $createCustomFieldResult
     */
    public function __construct(array $createCustomFieldResult = array())
    {
        $this
            ->setCreateCustomFieldResult($createCustomFieldResult);
    }
    /**
     * Get CreateCustomFieldResult value
     * @return \StructType\CreateCustomFieldResult[]|null
     */
    public function getCreateCustomFieldResult()
    {
        return $this->CreateCustomFieldResult;
    }
    /**
     * This method is responsible for validating the values passed to the setCreateCustomFieldResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCreateCustomFieldResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCreateCustomFieldResultForArrayConstraintsFromSetCreateCustomFieldResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createCustomFieldResultArrayCreateCustomFieldResultItem) {
            // validation for constraint: itemType
            if (!$createCustomFieldResultArrayCreateCustomFieldResultItem instanceof \StructType\CreateCustomFieldResult) {
                $invalidValues[] = is_object($createCustomFieldResultArrayCreateCustomFieldResultItem) ? get_class($createCustomFieldResultArrayCreateCustomFieldResultItem) : sprintf('%s(%s)', gettype($createCustomFieldResultArrayCreateCustomFieldResultItem), var_export($createCustomFieldResultArrayCreateCustomFieldResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CreateCustomFieldResult property can only contain items of type \StructType\CreateCustomFieldResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CreateCustomFieldResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateCustomFieldResult[] $createCustomFieldResult
     * @return \ArrayType\CreateCustomFieldResultArray
     */
    public function setCreateCustomFieldResult(array $createCustomFieldResult = array())
    {
        // validation for constraint: array
        if ('' !== ($createCustomFieldResultArrayErrorMessage = self::validateCreateCustomFieldResultForArrayConstraintsFromSetCreateCustomFieldResult($createCustomFieldResult))) {
            throw new \InvalidArgumentException($createCustomFieldResultArrayErrorMessage, __LINE__);
        }
        $this->CreateCustomFieldResult = $createCustomFieldResult;
        return $this;
    }
    /**
     * Add item to CreateCustomFieldResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateCustomFieldResult $item
     * @return \ArrayType\CreateCustomFieldResultArray
     */
    public function addToCreateCustomFieldResult(\StructType\CreateCustomFieldResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CreateCustomFieldResult) {
            throw new \InvalidArgumentException(sprintf('The CreateCustomFieldResult property can only contain items of type \StructType\CreateCustomFieldResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CreateCustomFieldResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CreateCustomFieldResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CreateCustomFieldResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CreateCustomFieldResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CreateCustomFieldResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CreateCustomFieldResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CreateCustomFieldResult
     */
    public function getAttributeName()
    {
        return 'CreateCustomFieldResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\CreateCustomFieldResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
