<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for CreateMeetingRequestResultArray ArrayType
 * @subpackage Arrays
 */
class CreateMeetingRequestResultArray extends AbstractStructArrayBase
{
    /**
     * The CreateMeetingRequestResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CreateMeetingRequestResult[]
     */
    public $CreateMeetingRequestResult;
    /**
     * Constructor method for CreateMeetingRequestResultArray
     * @uses CreateMeetingRequestResultArray::setCreateMeetingRequestResult()
     * @param \StructType\CreateMeetingRequestResult[] $createMeetingRequestResult
     */
    public function __construct(array $createMeetingRequestResult = array())
    {
        $this
            ->setCreateMeetingRequestResult($createMeetingRequestResult);
    }
    /**
     * Get CreateMeetingRequestResult value
     * @return \StructType\CreateMeetingRequestResult[]|null
     */
    public function getCreateMeetingRequestResult()
    {
        return $this->CreateMeetingRequestResult;
    }
    /**
     * This method is responsible for validating the values passed to the setCreateMeetingRequestResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCreateMeetingRequestResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCreateMeetingRequestResultForArrayConstraintsFromSetCreateMeetingRequestResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createMeetingRequestResultArrayCreateMeetingRequestResultItem) {
            // validation for constraint: itemType
            if (!$createMeetingRequestResultArrayCreateMeetingRequestResultItem instanceof \StructType\CreateMeetingRequestResult) {
                $invalidValues[] = is_object($createMeetingRequestResultArrayCreateMeetingRequestResultItem) ? get_class($createMeetingRequestResultArrayCreateMeetingRequestResultItem) : sprintf('%s(%s)', gettype($createMeetingRequestResultArrayCreateMeetingRequestResultItem), var_export($createMeetingRequestResultArrayCreateMeetingRequestResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CreateMeetingRequestResult property can only contain items of type \StructType\CreateMeetingRequestResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CreateMeetingRequestResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateMeetingRequestResult[] $createMeetingRequestResult
     * @return \ArrayType\CreateMeetingRequestResultArray
     */
    public function setCreateMeetingRequestResult(array $createMeetingRequestResult = array())
    {
        // validation for constraint: array
        if ('' !== ($createMeetingRequestResultArrayErrorMessage = self::validateCreateMeetingRequestResultForArrayConstraintsFromSetCreateMeetingRequestResult($createMeetingRequestResult))) {
            throw new \InvalidArgumentException($createMeetingRequestResultArrayErrorMessage, __LINE__);
        }
        $this->CreateMeetingRequestResult = $createMeetingRequestResult;
        return $this;
    }
    /**
     * Add item to CreateMeetingRequestResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateMeetingRequestResult $item
     * @return \ArrayType\CreateMeetingRequestResultArray
     */
    public function addToCreateMeetingRequestResult(\StructType\CreateMeetingRequestResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CreateMeetingRequestResult) {
            throw new \InvalidArgumentException(sprintf('The CreateMeetingRequestResult property can only contain items of type \StructType\CreateMeetingRequestResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CreateMeetingRequestResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CreateMeetingRequestResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CreateMeetingRequestResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CreateMeetingRequestResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CreateMeetingRequestResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CreateMeetingRequestResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CreateMeetingRequestResult
     */
    public function getAttributeName()
    {
        return 'CreateMeetingRequestResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\CreateMeetingRequestResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
