<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for CreateNoRegEventResultArray ArrayType
 * @subpackage Arrays
 */
class CreateNoRegEventResultArray extends AbstractStructArrayBase
{
    /**
     * The CreateNoRegEventResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CreateNoRegEventResult[]
     */
    public $CreateNoRegEventResult;
    /**
     * Constructor method for CreateNoRegEventResultArray
     * @uses CreateNoRegEventResultArray::setCreateNoRegEventResult()
     * @param \StructType\CreateNoRegEventResult[] $createNoRegEventResult
     */
    public function __construct(array $createNoRegEventResult = array())
    {
        $this
            ->setCreateNoRegEventResult($createNoRegEventResult);
    }
    /**
     * Get CreateNoRegEventResult value
     * @return \StructType\CreateNoRegEventResult[]|null
     */
    public function getCreateNoRegEventResult()
    {
        return $this->CreateNoRegEventResult;
    }
    /**
     * This method is responsible for validating the values passed to the setCreateNoRegEventResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCreateNoRegEventResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCreateNoRegEventResultForArrayConstraintsFromSetCreateNoRegEventResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createNoRegEventResultArrayCreateNoRegEventResultItem) {
            // validation for constraint: itemType
            if (!$createNoRegEventResultArrayCreateNoRegEventResultItem instanceof \StructType\CreateNoRegEventResult) {
                $invalidValues[] = is_object($createNoRegEventResultArrayCreateNoRegEventResultItem) ? get_class($createNoRegEventResultArrayCreateNoRegEventResultItem) : sprintf('%s(%s)', gettype($createNoRegEventResultArrayCreateNoRegEventResultItem), var_export($createNoRegEventResultArrayCreateNoRegEventResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CreateNoRegEventResult property can only contain items of type \StructType\CreateNoRegEventResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CreateNoRegEventResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateNoRegEventResult[] $createNoRegEventResult
     * @return \ArrayType\CreateNoRegEventResultArray
     */
    public function setCreateNoRegEventResult(array $createNoRegEventResult = array())
    {
        // validation for constraint: array
        if ('' !== ($createNoRegEventResultArrayErrorMessage = self::validateCreateNoRegEventResultForArrayConstraintsFromSetCreateNoRegEventResult($createNoRegEventResult))) {
            throw new \InvalidArgumentException($createNoRegEventResultArrayErrorMessage, __LINE__);
        }
        $this->CreateNoRegEventResult = $createNoRegEventResult;
        return $this;
    }
    /**
     * Add item to CreateNoRegEventResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateNoRegEventResult $item
     * @return \ArrayType\CreateNoRegEventResultArray
     */
    public function addToCreateNoRegEventResult(\StructType\CreateNoRegEventResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CreateNoRegEventResult) {
            throw new \InvalidArgumentException(sprintf('The CreateNoRegEventResult property can only contain items of type \StructType\CreateNoRegEventResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CreateNoRegEventResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CreateNoRegEventResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CreateNoRegEventResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CreateNoRegEventResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CreateNoRegEventResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CreateNoRegEventResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CreateNoRegEventResult
     */
    public function getAttributeName()
    {
        return 'CreateNoRegEventResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\CreateNoRegEventResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
