<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for CreateRFPResultArray ArrayType
 * @subpackage Arrays
 */
class CreateRFPResultArray extends AbstractStructArrayBase
{
    /**
     * The CreateRFPResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CreateRFPResult[]
     */
    public $CreateRFPResult;
    /**
     * Constructor method for CreateRFPResultArray
     * @uses CreateRFPResultArray::setCreateRFPResult()
     * @param \StructType\CreateRFPResult[] $createRFPResult
     */
    public function __construct(array $createRFPResult = array())
    {
        $this
            ->setCreateRFPResult($createRFPResult);
    }
    /**
     * Get CreateRFPResult value
     * @return \StructType\CreateRFPResult[]|null
     */
    public function getCreateRFPResult()
    {
        return $this->CreateRFPResult;
    }
    /**
     * This method is responsible for validating the values passed to the setCreateRFPResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCreateRFPResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCreateRFPResultForArrayConstraintsFromSetCreateRFPResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createRFPResultArrayCreateRFPResultItem) {
            // validation for constraint: itemType
            if (!$createRFPResultArrayCreateRFPResultItem instanceof \StructType\CreateRFPResult) {
                $invalidValues[] = is_object($createRFPResultArrayCreateRFPResultItem) ? get_class($createRFPResultArrayCreateRFPResultItem) : sprintf('%s(%s)', gettype($createRFPResultArrayCreateRFPResultItem), var_export($createRFPResultArrayCreateRFPResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CreateRFPResult property can only contain items of type \StructType\CreateRFPResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CreateRFPResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateRFPResult[] $createRFPResult
     * @return \ArrayType\CreateRFPResultArray
     */
    public function setCreateRFPResult(array $createRFPResult = array())
    {
        // validation for constraint: array
        if ('' !== ($createRFPResultArrayErrorMessage = self::validateCreateRFPResultForArrayConstraintsFromSetCreateRFPResult($createRFPResult))) {
            throw new \InvalidArgumentException($createRFPResultArrayErrorMessage, __LINE__);
        }
        $this->CreateRFPResult = $createRFPResult;
        return $this;
    }
    /**
     * Add item to CreateRFPResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateRFPResult $item
     * @return \ArrayType\CreateRFPResultArray
     */
    public function addToCreateRFPResult(\StructType\CreateRFPResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CreateRFPResult) {
            throw new \InvalidArgumentException(sprintf('The CreateRFPResult property can only contain items of type \StructType\CreateRFPResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CreateRFPResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CreateRFPResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CreateRFPResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CreateRFPResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CreateRFPResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CreateRFPResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CreateRFPResult
     */
    public function getAttributeName()
    {
        return 'CreateRFPResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\CreateRFPResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
