<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for CreateRateHistoryResultArray ArrayType
 * @subpackage Arrays
 */
class CreateRateHistoryResultArray extends AbstractStructArrayBase
{
    /**
     * The CreateRateHistoryResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CreateRateHistoryResult[]
     */
    public $CreateRateHistoryResult;
    /**
     * Constructor method for CreateRateHistoryResultArray
     * @uses CreateRateHistoryResultArray::setCreateRateHistoryResult()
     * @param \StructType\CreateRateHistoryResult[] $createRateHistoryResult
     */
    public function __construct(array $createRateHistoryResult = array())
    {
        $this
            ->setCreateRateHistoryResult($createRateHistoryResult);
    }
    /**
     * Get CreateRateHistoryResult value
     * @return \StructType\CreateRateHistoryResult[]|null
     */
    public function getCreateRateHistoryResult()
    {
        return $this->CreateRateHistoryResult;
    }
    /**
     * This method is responsible for validating the values passed to the setCreateRateHistoryResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCreateRateHistoryResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCreateRateHistoryResultForArrayConstraintsFromSetCreateRateHistoryResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createRateHistoryResultArrayCreateRateHistoryResultItem) {
            // validation for constraint: itemType
            if (!$createRateHistoryResultArrayCreateRateHistoryResultItem instanceof \StructType\CreateRateHistoryResult) {
                $invalidValues[] = is_object($createRateHistoryResultArrayCreateRateHistoryResultItem) ? get_class($createRateHistoryResultArrayCreateRateHistoryResultItem) : sprintf('%s(%s)', gettype($createRateHistoryResultArrayCreateRateHistoryResultItem), var_export($createRateHistoryResultArrayCreateRateHistoryResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CreateRateHistoryResult property can only contain items of type \StructType\CreateRateHistoryResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CreateRateHistoryResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateRateHistoryResult[] $createRateHistoryResult
     * @return \ArrayType\CreateRateHistoryResultArray
     */
    public function setCreateRateHistoryResult(array $createRateHistoryResult = array())
    {
        // validation for constraint: array
        if ('' !== ($createRateHistoryResultArrayErrorMessage = self::validateCreateRateHistoryResultForArrayConstraintsFromSetCreateRateHistoryResult($createRateHistoryResult))) {
            throw new \InvalidArgumentException($createRateHistoryResultArrayErrorMessage, __LINE__);
        }
        $this->CreateRateHistoryResult = $createRateHistoryResult;
        return $this;
    }
    /**
     * Add item to CreateRateHistoryResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateRateHistoryResult $item
     * @return \ArrayType\CreateRateHistoryResultArray
     */
    public function addToCreateRateHistoryResult(\StructType\CreateRateHistoryResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CreateRateHistoryResult) {
            throw new \InvalidArgumentException(sprintf('The CreateRateHistoryResult property can only contain items of type \StructType\CreateRateHistoryResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CreateRateHistoryResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CreateRateHistoryResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CreateRateHistoryResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CreateRateHistoryResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CreateRateHistoryResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CreateRateHistoryResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CreateRateHistoryResult
     */
    public function getAttributeName()
    {
        return 'CreateRateHistoryResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\CreateRateHistoryResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
