<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for CreateSessionResultArray ArrayType
 * @subpackage Arrays
 */
class CreateSessionResultArray extends AbstractStructArrayBase
{
    /**
     * The CreateSessionResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CreateSessionResult[]
     */
    public $CreateSessionResult;
    /**
     * Constructor method for CreateSessionResultArray
     * @uses CreateSessionResultArray::setCreateSessionResult()
     * @param \StructType\CreateSessionResult[] $createSessionResult
     */
    public function __construct(array $createSessionResult = array())
    {
        $this
            ->setCreateSessionResult($createSessionResult);
    }
    /**
     * Get CreateSessionResult value
     * @return \StructType\CreateSessionResult[]|null
     */
    public function getCreateSessionResult()
    {
        return $this->CreateSessionResult;
    }
    /**
     * This method is responsible for validating the values passed to the setCreateSessionResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCreateSessionResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCreateSessionResultForArrayConstraintsFromSetCreateSessionResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createSessionResultArrayCreateSessionResultItem) {
            // validation for constraint: itemType
            if (!$createSessionResultArrayCreateSessionResultItem instanceof \StructType\CreateSessionResult) {
                $invalidValues[] = is_object($createSessionResultArrayCreateSessionResultItem) ? get_class($createSessionResultArrayCreateSessionResultItem) : sprintf('%s(%s)', gettype($createSessionResultArrayCreateSessionResultItem), var_export($createSessionResultArrayCreateSessionResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CreateSessionResult property can only contain items of type \StructType\CreateSessionResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CreateSessionResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateSessionResult[] $createSessionResult
     * @return \ArrayType\CreateSessionResultArray
     */
    public function setCreateSessionResult(array $createSessionResult = array())
    {
        // validation for constraint: array
        if ('' !== ($createSessionResultArrayErrorMessage = self::validateCreateSessionResultForArrayConstraintsFromSetCreateSessionResult($createSessionResult))) {
            throw new \InvalidArgumentException($createSessionResultArrayErrorMessage, __LINE__);
        }
        $this->CreateSessionResult = $createSessionResult;
        return $this;
    }
    /**
     * Add item to CreateSessionResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateSessionResult $item
     * @return \ArrayType\CreateSessionResultArray
     */
    public function addToCreateSessionResult(\StructType\CreateSessionResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CreateSessionResult) {
            throw new \InvalidArgumentException(sprintf('The CreateSessionResult property can only contain items of type \StructType\CreateSessionResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CreateSessionResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CreateSessionResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CreateSessionResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CreateSessionResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CreateSessionResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CreateSessionResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CreateSessionResult
     */
    public function getAttributeName()
    {
        return 'CreateSessionResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\CreateSessionResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
