<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for CreateSurveyAnswerResultArray ArrayType
 * @subpackage Arrays
 */
class CreateSurveyAnswerResultArray extends AbstractStructArrayBase
{
    /**
     * The CreateSurveyAnswerResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CreateSurveyAnswerResult[]
     */
    public $CreateSurveyAnswerResult;
    /**
     * Constructor method for CreateSurveyAnswerResultArray
     * @uses CreateSurveyAnswerResultArray::setCreateSurveyAnswerResult()
     * @param \StructType\CreateSurveyAnswerResult[] $createSurveyAnswerResult
     */
    public function __construct(array $createSurveyAnswerResult = array())
    {
        $this
            ->setCreateSurveyAnswerResult($createSurveyAnswerResult);
    }
    /**
     * Get CreateSurveyAnswerResult value
     * @return \StructType\CreateSurveyAnswerResult[]|null
     */
    public function getCreateSurveyAnswerResult()
    {
        return $this->CreateSurveyAnswerResult;
    }
    /**
     * This method is responsible for validating the values passed to the setCreateSurveyAnswerResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCreateSurveyAnswerResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCreateSurveyAnswerResultForArrayConstraintsFromSetCreateSurveyAnswerResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createSurveyAnswerResultArrayCreateSurveyAnswerResultItem) {
            // validation for constraint: itemType
            if (!$createSurveyAnswerResultArrayCreateSurveyAnswerResultItem instanceof \StructType\CreateSurveyAnswerResult) {
                $invalidValues[] = is_object($createSurveyAnswerResultArrayCreateSurveyAnswerResultItem) ? get_class($createSurveyAnswerResultArrayCreateSurveyAnswerResultItem) : sprintf('%s(%s)', gettype($createSurveyAnswerResultArrayCreateSurveyAnswerResultItem), var_export($createSurveyAnswerResultArrayCreateSurveyAnswerResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CreateSurveyAnswerResult property can only contain items of type \StructType\CreateSurveyAnswerResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CreateSurveyAnswerResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateSurveyAnswerResult[] $createSurveyAnswerResult
     * @return \ArrayType\CreateSurveyAnswerResultArray
     */
    public function setCreateSurveyAnswerResult(array $createSurveyAnswerResult = array())
    {
        // validation for constraint: array
        if ('' !== ($createSurveyAnswerResultArrayErrorMessage = self::validateCreateSurveyAnswerResultForArrayConstraintsFromSetCreateSurveyAnswerResult($createSurveyAnswerResult))) {
            throw new \InvalidArgumentException($createSurveyAnswerResultArrayErrorMessage, __LINE__);
        }
        $this->CreateSurveyAnswerResult = $createSurveyAnswerResult;
        return $this;
    }
    /**
     * Add item to CreateSurveyAnswerResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateSurveyAnswerResult $item
     * @return \ArrayType\CreateSurveyAnswerResultArray
     */
    public function addToCreateSurveyAnswerResult(\StructType\CreateSurveyAnswerResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CreateSurveyAnswerResult) {
            throw new \InvalidArgumentException(sprintf('The CreateSurveyAnswerResult property can only contain items of type \StructType\CreateSurveyAnswerResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CreateSurveyAnswerResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CreateSurveyAnswerResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CreateSurveyAnswerResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CreateSurveyAnswerResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CreateSurveyAnswerResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CreateSurveyAnswerResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CreateSurveyAnswerResult
     */
    public function getAttributeName()
    {
        return 'CreateSurveyAnswerResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\CreateSurveyAnswerResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
