<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for CreateTransactionResultArray ArrayType
 * @subpackage Arrays
 */
class CreateTransactionResultArray extends AbstractStructArrayBase
{
    /**
     * The CreateTransactionResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CreateTransactionResult[]
     */
    public $CreateTransactionResult;
    /**
     * Constructor method for CreateTransactionResultArray
     * @uses CreateTransactionResultArray::setCreateTransactionResult()
     * @param \StructType\CreateTransactionResult[] $createTransactionResult
     */
    public function __construct(array $createTransactionResult = array())
    {
        $this
            ->setCreateTransactionResult($createTransactionResult);
    }
    /**
     * Get CreateTransactionResult value
     * @return \StructType\CreateTransactionResult[]|null
     */
    public function getCreateTransactionResult()
    {
        return $this->CreateTransactionResult;
    }
    /**
     * This method is responsible for validating the values passed to the setCreateTransactionResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCreateTransactionResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCreateTransactionResultForArrayConstraintsFromSetCreateTransactionResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createTransactionResultArrayCreateTransactionResultItem) {
            // validation for constraint: itemType
            if (!$createTransactionResultArrayCreateTransactionResultItem instanceof \StructType\CreateTransactionResult) {
                $invalidValues[] = is_object($createTransactionResultArrayCreateTransactionResultItem) ? get_class($createTransactionResultArrayCreateTransactionResultItem) : sprintf('%s(%s)', gettype($createTransactionResultArrayCreateTransactionResultItem), var_export($createTransactionResultArrayCreateTransactionResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CreateTransactionResult property can only contain items of type \StructType\CreateTransactionResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CreateTransactionResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateTransactionResult[] $createTransactionResult
     * @return \ArrayType\CreateTransactionResultArray
     */
    public function setCreateTransactionResult(array $createTransactionResult = array())
    {
        // validation for constraint: array
        if ('' !== ($createTransactionResultArrayErrorMessage = self::validateCreateTransactionResultForArrayConstraintsFromSetCreateTransactionResult($createTransactionResult))) {
            throw new \InvalidArgumentException($createTransactionResultArrayErrorMessage, __LINE__);
        }
        $this->CreateTransactionResult = $createTransactionResult;
        return $this;
    }
    /**
     * Add item to CreateTransactionResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateTransactionResult $item
     * @return \ArrayType\CreateTransactionResultArray
     */
    public function addToCreateTransactionResult(\StructType\CreateTransactionResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CreateTransactionResult) {
            throw new \InvalidArgumentException(sprintf('The CreateTransactionResult property can only contain items of type \StructType\CreateTransactionResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CreateTransactionResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CreateTransactionResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CreateTransactionResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CreateTransactionResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CreateTransactionResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CreateTransactionResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CreateTransactionResult
     */
    public function getAttributeName()
    {
        return 'CreateTransactionResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\CreateTransactionResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
