<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for CreateUserResultArray ArrayType
 * @subpackage Arrays
 */
class CreateUserResultArray extends AbstractStructArrayBase
{
    /**
     * The CreateUserResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CreateUserResult[]
     */
    public $CreateUserResult;
    /**
     * Constructor method for CreateUserResultArray
     * @uses CreateUserResultArray::setCreateUserResult()
     * @param \StructType\CreateUserResult[] $createUserResult
     */
    public function __construct(array $createUserResult = array())
    {
        $this
            ->setCreateUserResult($createUserResult);
    }
    /**
     * Get CreateUserResult value
     * @return \StructType\CreateUserResult[]|null
     */
    public function getCreateUserResult()
    {
        return $this->CreateUserResult;
    }
    /**
     * This method is responsible for validating the values passed to the setCreateUserResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCreateUserResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCreateUserResultForArrayConstraintsFromSetCreateUserResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $createUserResultArrayCreateUserResultItem) {
            // validation for constraint: itemType
            if (!$createUserResultArrayCreateUserResultItem instanceof \StructType\CreateUserResult) {
                $invalidValues[] = is_object($createUserResultArrayCreateUserResultItem) ? get_class($createUserResultArrayCreateUserResultItem) : sprintf('%s(%s)', gettype($createUserResultArrayCreateUserResultItem), var_export($createUserResultArrayCreateUserResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CreateUserResult property can only contain items of type \StructType\CreateUserResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CreateUserResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateUserResult[] $createUserResult
     * @return \ArrayType\CreateUserResultArray
     */
    public function setCreateUserResult(array $createUserResult = array())
    {
        // validation for constraint: array
        if ('' !== ($createUserResultArrayErrorMessage = self::validateCreateUserResultForArrayConstraintsFromSetCreateUserResult($createUserResult))) {
            throw new \InvalidArgumentException($createUserResultArrayErrorMessage, __LINE__);
        }
        $this->CreateUserResult = $createUserResult;
        return $this;
    }
    /**
     * Add item to CreateUserResult value
     * @throws \InvalidArgumentException
     * @param \StructType\CreateUserResult $item
     * @return \ArrayType\CreateUserResultArray
     */
    public function addToCreateUserResult(\StructType\CreateUserResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CreateUserResult) {
            throw new \InvalidArgumentException(sprintf('The CreateUserResult property can only contain items of type \StructType\CreateUserResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CreateUserResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\CreateUserResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\CreateUserResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\CreateUserResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\CreateUserResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\CreateUserResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string CreateUserResult
     */
    public function getAttributeName()
    {
        return 'CreateUserResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\CreateUserResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
