<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for DeleteApproverResultArray ArrayType
 * @subpackage Arrays
 */
class DeleteApproverResultArray extends AbstractStructArrayBase
{
    /**
     * The DeleteApproverResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\DeleteApproverResult[]
     */
    public $DeleteApproverResult;
    /**
     * Constructor method for DeleteApproverResultArray
     * @uses DeleteApproverResultArray::setDeleteApproverResult()
     * @param \StructType\DeleteApproverResult[] $deleteApproverResult
     */
    public function __construct(array $deleteApproverResult = array())
    {
        $this
            ->setDeleteApproverResult($deleteApproverResult);
    }
    /**
     * Get DeleteApproverResult value
     * @return \StructType\DeleteApproverResult[]|null
     */
    public function getDeleteApproverResult()
    {
        return $this->DeleteApproverResult;
    }
    /**
     * This method is responsible for validating the values passed to the setDeleteApproverResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeleteApproverResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeleteApproverResultForArrayConstraintsFromSetDeleteApproverResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $deleteApproverResultArrayDeleteApproverResultItem) {
            // validation for constraint: itemType
            if (!$deleteApproverResultArrayDeleteApproverResultItem instanceof \StructType\DeleteApproverResult) {
                $invalidValues[] = is_object($deleteApproverResultArrayDeleteApproverResultItem) ? get_class($deleteApproverResultArrayDeleteApproverResultItem) : sprintf('%s(%s)', gettype($deleteApproverResultArrayDeleteApproverResultItem), var_export($deleteApproverResultArrayDeleteApproverResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DeleteApproverResult property can only contain items of type \StructType\DeleteApproverResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DeleteApproverResult value
     * @throws \InvalidArgumentException
     * @param \StructType\DeleteApproverResult[] $deleteApproverResult
     * @return \ArrayType\DeleteApproverResultArray
     */
    public function setDeleteApproverResult(array $deleteApproverResult = array())
    {
        // validation for constraint: array
        if ('' !== ($deleteApproverResultArrayErrorMessage = self::validateDeleteApproverResultForArrayConstraintsFromSetDeleteApproverResult($deleteApproverResult))) {
            throw new \InvalidArgumentException($deleteApproverResultArrayErrorMessage, __LINE__);
        }
        $this->DeleteApproverResult = $deleteApproverResult;
        return $this;
    }
    /**
     * Add item to DeleteApproverResult value
     * @throws \InvalidArgumentException
     * @param \StructType\DeleteApproverResult $item
     * @return \ArrayType\DeleteApproverResultArray
     */
    public function addToDeleteApproverResult(\StructType\DeleteApproverResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DeleteApproverResult) {
            throw new \InvalidArgumentException(sprintf('The DeleteApproverResult property can only contain items of type \StructType\DeleteApproverResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DeleteApproverResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DeleteApproverResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DeleteApproverResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DeleteApproverResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DeleteApproverResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DeleteApproverResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeleteApproverResult
     */
    public function getAttributeName()
    {
        return 'DeleteApproverResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\DeleteApproverResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
