<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for DeleteRateHistoryResultArray ArrayType
 * @subpackage Arrays
 */
class DeleteRateHistoryResultArray extends AbstractStructArrayBase
{
    /**
     * The DeleteRateHistoryResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\DeleteRateHistoryResult[]
     */
    public $DeleteRateHistoryResult;
    /**
     * Constructor method for DeleteRateHistoryResultArray
     * @uses DeleteRateHistoryResultArray::setDeleteRateHistoryResult()
     * @param \StructType\DeleteRateHistoryResult[] $deleteRateHistoryResult
     */
    public function __construct(array $deleteRateHistoryResult = array())
    {
        $this
            ->setDeleteRateHistoryResult($deleteRateHistoryResult);
    }
    /**
     * Get DeleteRateHistoryResult value
     * @return \StructType\DeleteRateHistoryResult[]|null
     */
    public function getDeleteRateHistoryResult()
    {
        return $this->DeleteRateHistoryResult;
    }
    /**
     * This method is responsible for validating the values passed to the setDeleteRateHistoryResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDeleteRateHistoryResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDeleteRateHistoryResultForArrayConstraintsFromSetDeleteRateHistoryResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $deleteRateHistoryResultArrayDeleteRateHistoryResultItem) {
            // validation for constraint: itemType
            if (!$deleteRateHistoryResultArrayDeleteRateHistoryResultItem instanceof \StructType\DeleteRateHistoryResult) {
                $invalidValues[] = is_object($deleteRateHistoryResultArrayDeleteRateHistoryResultItem) ? get_class($deleteRateHistoryResultArrayDeleteRateHistoryResultItem) : sprintf('%s(%s)', gettype($deleteRateHistoryResultArrayDeleteRateHistoryResultItem), var_export($deleteRateHistoryResultArrayDeleteRateHistoryResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DeleteRateHistoryResult property can only contain items of type \StructType\DeleteRateHistoryResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DeleteRateHistoryResult value
     * @throws \InvalidArgumentException
     * @param \StructType\DeleteRateHistoryResult[] $deleteRateHistoryResult
     * @return \ArrayType\DeleteRateHistoryResultArray
     */
    public function setDeleteRateHistoryResult(array $deleteRateHistoryResult = array())
    {
        // validation for constraint: array
        if ('' !== ($deleteRateHistoryResultArrayErrorMessage = self::validateDeleteRateHistoryResultForArrayConstraintsFromSetDeleteRateHistoryResult($deleteRateHistoryResult))) {
            throw new \InvalidArgumentException($deleteRateHistoryResultArrayErrorMessage, __LINE__);
        }
        $this->DeleteRateHistoryResult = $deleteRateHistoryResult;
        return $this;
    }
    /**
     * Add item to DeleteRateHistoryResult value
     * @throws \InvalidArgumentException
     * @param \StructType\DeleteRateHistoryResult $item
     * @return \ArrayType\DeleteRateHistoryResultArray
     */
    public function addToDeleteRateHistoryResult(\StructType\DeleteRateHistoryResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DeleteRateHistoryResult) {
            throw new \InvalidArgumentException(sprintf('The DeleteRateHistoryResult property can only contain items of type \StructType\DeleteRateHistoryResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DeleteRateHistoryResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DeleteRateHistoryResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DeleteRateHistoryResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DeleteRateHistoryResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DeleteRateHistoryResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DeleteRateHistoryResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DeleteRateHistoryResult
     */
    public function getAttributeName()
    {
        return 'DeleteRateHistoryResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\DeleteRateHistoryResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
