<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ManageContactGroupMembersResultArray ArrayType
 * @subpackage Arrays
 */
class ManageContactGroupMembersResultArray extends AbstractStructArrayBase
{
    /**
     * The ManageContactGroupResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ManageContactGroupResult[]
     */
    public $ManageContactGroupResult;
    /**
     * Constructor method for ManageContactGroupMembersResultArray
     * @uses ManageContactGroupMembersResultArray::setManageContactGroupResult()
     * @param \StructType\ManageContactGroupResult[] $manageContactGroupResult
     */
    public function __construct(array $manageContactGroupResult = array())
    {
        $this
            ->setManageContactGroupResult($manageContactGroupResult);
    }
    /**
     * Get ManageContactGroupResult value
     * @return \StructType\ManageContactGroupResult[]|null
     */
    public function getManageContactGroupResult()
    {
        return $this->ManageContactGroupResult;
    }
    /**
     * This method is responsible for validating the values passed to the setManageContactGroupResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setManageContactGroupResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateManageContactGroupResultForArrayConstraintsFromSetManageContactGroupResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $manageContactGroupMembersResultArrayManageContactGroupResultItem) {
            // validation for constraint: itemType
            if (!$manageContactGroupMembersResultArrayManageContactGroupResultItem instanceof \StructType\ManageContactGroupResult) {
                $invalidValues[] = is_object($manageContactGroupMembersResultArrayManageContactGroupResultItem) ? get_class($manageContactGroupMembersResultArrayManageContactGroupResultItem) : sprintf('%s(%s)', gettype($manageContactGroupMembersResultArrayManageContactGroupResultItem), var_export($manageContactGroupMembersResultArrayManageContactGroupResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ManageContactGroupResult property can only contain items of type \StructType\ManageContactGroupResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ManageContactGroupResult value
     * @throws \InvalidArgumentException
     * @param \StructType\ManageContactGroupResult[] $manageContactGroupResult
     * @return \ArrayType\ManageContactGroupMembersResultArray
     */
    public function setManageContactGroupResult(array $manageContactGroupResult = array())
    {
        // validation for constraint: array
        if ('' !== ($manageContactGroupResultArrayErrorMessage = self::validateManageContactGroupResultForArrayConstraintsFromSetManageContactGroupResult($manageContactGroupResult))) {
            throw new \InvalidArgumentException($manageContactGroupResultArrayErrorMessage, __LINE__);
        }
        $this->ManageContactGroupResult = $manageContactGroupResult;
        return $this;
    }
    /**
     * Add item to ManageContactGroupResult value
     * @throws \InvalidArgumentException
     * @param \StructType\ManageContactGroupResult $item
     * @return \ArrayType\ManageContactGroupMembersResultArray
     */
    public function addToManageContactGroupResult(\StructType\ManageContactGroupResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ManageContactGroupResult) {
            throw new \InvalidArgumentException(sprintf('The ManageContactGroupResult property can only contain items of type \StructType\ManageContactGroupResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ManageContactGroupResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ManageContactGroupResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ManageContactGroupResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ManageContactGroupResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ManageContactGroupResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ManageContactGroupResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ManageContactGroupResult
     */
    public function getAttributeName()
    {
        return 'ManageContactGroupResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ManageContactGroupMembersResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
