<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ManageDistributionListMembersResultArray ArrayType
 * @subpackage Arrays
 */
class ManageDistributionListMembersResultArray extends AbstractStructArrayBase
{
    /**
     * The ManageDistributionListResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ManageDistributionListResult[]
     */
    public $ManageDistributionListResult;
    /**
     * Constructor method for ManageDistributionListMembersResultArray
     * @uses ManageDistributionListMembersResultArray::setManageDistributionListResult()
     * @param \StructType\ManageDistributionListResult[] $manageDistributionListResult
     */
    public function __construct(array $manageDistributionListResult = array())
    {
        $this
            ->setManageDistributionListResult($manageDistributionListResult);
    }
    /**
     * Get ManageDistributionListResult value
     * @return \StructType\ManageDistributionListResult[]|null
     */
    public function getManageDistributionListResult()
    {
        return $this->ManageDistributionListResult;
    }
    /**
     * This method is responsible for validating the values passed to the setManageDistributionListResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setManageDistributionListResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateManageDistributionListResultForArrayConstraintsFromSetManageDistributionListResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $manageDistributionListMembersResultArrayManageDistributionListResultItem) {
            // validation for constraint: itemType
            if (!$manageDistributionListMembersResultArrayManageDistributionListResultItem instanceof \StructType\ManageDistributionListResult) {
                $invalidValues[] = is_object($manageDistributionListMembersResultArrayManageDistributionListResultItem) ? get_class($manageDistributionListMembersResultArrayManageDistributionListResultItem) : sprintf('%s(%s)', gettype($manageDistributionListMembersResultArrayManageDistributionListResultItem), var_export($manageDistributionListMembersResultArrayManageDistributionListResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ManageDistributionListResult property can only contain items of type \StructType\ManageDistributionListResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ManageDistributionListResult value
     * @throws \InvalidArgumentException
     * @param \StructType\ManageDistributionListResult[] $manageDistributionListResult
     * @return \ArrayType\ManageDistributionListMembersResultArray
     */
    public function setManageDistributionListResult(array $manageDistributionListResult = array())
    {
        // validation for constraint: array
        if ('' !== ($manageDistributionListResultArrayErrorMessage = self::validateManageDistributionListResultForArrayConstraintsFromSetManageDistributionListResult($manageDistributionListResult))) {
            throw new \InvalidArgumentException($manageDistributionListResultArrayErrorMessage, __LINE__);
        }
        $this->ManageDistributionListResult = $manageDistributionListResult;
        return $this;
    }
    /**
     * Add item to ManageDistributionListResult value
     * @throws \InvalidArgumentException
     * @param \StructType\ManageDistributionListResult $item
     * @return \ArrayType\ManageDistributionListMembersResultArray
     */
    public function addToManageDistributionListResult(\StructType\ManageDistributionListResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ManageDistributionListResult) {
            throw new \InvalidArgumentException(sprintf('The ManageDistributionListResult property can only contain items of type \StructType\ManageDistributionListResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ManageDistributionListResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ManageDistributionListResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ManageDistributionListResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ManageDistributionListResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ManageDistributionListResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ManageDistributionListResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ManageDistributionListResult
     */
    public function getAttributeName()
    {
        return 'ManageDistributionListResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ManageDistributionListMembersResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
