<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ManageUserGroupResultArray ArrayType
 * @subpackage Arrays
 */
class ManageUserGroupResultArray extends AbstractStructArrayBase
{
    /**
     * The ManageUserGroupResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ManageUserGroupResult[]
     */
    public $ManageUserGroupResult;
    /**
     * Constructor method for ManageUserGroupResultArray
     * @uses ManageUserGroupResultArray::setManageUserGroupResult()
     * @param \StructType\ManageUserGroupResult[] $manageUserGroupResult
     */
    public function __construct(array $manageUserGroupResult = array())
    {
        $this
            ->setManageUserGroupResult($manageUserGroupResult);
    }
    /**
     * Get ManageUserGroupResult value
     * @return \StructType\ManageUserGroupResult[]|null
     */
    public function getManageUserGroupResult()
    {
        return $this->ManageUserGroupResult;
    }
    /**
     * This method is responsible for validating the values passed to the setManageUserGroupResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setManageUserGroupResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateManageUserGroupResultForArrayConstraintsFromSetManageUserGroupResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $manageUserGroupResultArrayManageUserGroupResultItem) {
            // validation for constraint: itemType
            if (!$manageUserGroupResultArrayManageUserGroupResultItem instanceof \StructType\ManageUserGroupResult) {
                $invalidValues[] = is_object($manageUserGroupResultArrayManageUserGroupResultItem) ? get_class($manageUserGroupResultArrayManageUserGroupResultItem) : sprintf('%s(%s)', gettype($manageUserGroupResultArrayManageUserGroupResultItem), var_export($manageUserGroupResultArrayManageUserGroupResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ManageUserGroupResult property can only contain items of type \StructType\ManageUserGroupResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ManageUserGroupResult value
     * @throws \InvalidArgumentException
     * @param \StructType\ManageUserGroupResult[] $manageUserGroupResult
     * @return \ArrayType\ManageUserGroupResultArray
     */
    public function setManageUserGroupResult(array $manageUserGroupResult = array())
    {
        // validation for constraint: array
        if ('' !== ($manageUserGroupResultArrayErrorMessage = self::validateManageUserGroupResultForArrayConstraintsFromSetManageUserGroupResult($manageUserGroupResult))) {
            throw new \InvalidArgumentException($manageUserGroupResultArrayErrorMessage, __LINE__);
        }
        $this->ManageUserGroupResult = $manageUserGroupResult;
        return $this;
    }
    /**
     * Add item to ManageUserGroupResult value
     * @throws \InvalidArgumentException
     * @param \StructType\ManageUserGroupResult $item
     * @return \ArrayType\ManageUserGroupResultArray
     */
    public function addToManageUserGroupResult(\StructType\ManageUserGroupResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ManageUserGroupResult) {
            throw new \InvalidArgumentException(sprintf('The ManageUserGroupResult property can only contain items of type \StructType\ManageUserGroupResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ManageUserGroupResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ManageUserGroupResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ManageUserGroupResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ManageUserGroupResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ManageUserGroupResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ManageUserGroupResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ManageUserGroupResult
     */
    public function getAttributeName()
    {
        return 'ManageUserGroupResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ManageUserGroupResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
