<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for SessionRegActionResultArray ArrayType
 * @subpackage Arrays
 */
class SessionRegActionResultArray extends AbstractStructArrayBase
{
    /**
     * The SessionRegActionResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\SessionRegActionResult[]
     */
    public $SessionRegActionResult;
    /**
     * Constructor method for SessionRegActionResultArray
     * @uses SessionRegActionResultArray::setSessionRegActionResult()
     * @param \StructType\SessionRegActionResult[] $sessionRegActionResult
     */
    public function __construct(array $sessionRegActionResult = array())
    {
        $this
            ->setSessionRegActionResult($sessionRegActionResult);
    }
    /**
     * Get SessionRegActionResult value
     * @return \StructType\SessionRegActionResult[]|null
     */
    public function getSessionRegActionResult()
    {
        return $this->SessionRegActionResult;
    }
    /**
     * This method is responsible for validating the values passed to the setSessionRegActionResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setSessionRegActionResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateSessionRegActionResultForArrayConstraintsFromSetSessionRegActionResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $sessionRegActionResultArraySessionRegActionResultItem) {
            // validation for constraint: itemType
            if (!$sessionRegActionResultArraySessionRegActionResultItem instanceof \StructType\SessionRegActionResult) {
                $invalidValues[] = is_object($sessionRegActionResultArraySessionRegActionResultItem) ? get_class($sessionRegActionResultArraySessionRegActionResultItem) : sprintf('%s(%s)', gettype($sessionRegActionResultArraySessionRegActionResultItem), var_export($sessionRegActionResultArraySessionRegActionResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The SessionRegActionResult property can only contain items of type \StructType\SessionRegActionResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set SessionRegActionResult value
     * @throws \InvalidArgumentException
     * @param \StructType\SessionRegActionResult[] $sessionRegActionResult
     * @return \ArrayType\SessionRegActionResultArray
     */
    public function setSessionRegActionResult(array $sessionRegActionResult = array())
    {
        // validation for constraint: array
        if ('' !== ($sessionRegActionResultArrayErrorMessage = self::validateSessionRegActionResultForArrayConstraintsFromSetSessionRegActionResult($sessionRegActionResult))) {
            throw new \InvalidArgumentException($sessionRegActionResultArrayErrorMessage, __LINE__);
        }
        $this->SessionRegActionResult = $sessionRegActionResult;
        return $this;
    }
    /**
     * Add item to SessionRegActionResult value
     * @throws \InvalidArgumentException
     * @param \StructType\SessionRegActionResult $item
     * @return \ArrayType\SessionRegActionResultArray
     */
    public function addToSessionRegActionResult(\StructType\SessionRegActionResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\SessionRegActionResult) {
            throw new \InvalidArgumentException(sprintf('The SessionRegActionResult property can only contain items of type \StructType\SessionRegActionResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->SessionRegActionResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\SessionRegActionResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\SessionRegActionResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\SessionRegActionResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\SessionRegActionResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\SessionRegActionResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string SessionRegActionResult
     */
    public function getAttributeName()
    {
        return 'SessionRegActionResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\SessionRegActionResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
