<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for UpdateCustomFieldResultArray ArrayType
 * @subpackage Arrays
 */
class UpdateCustomFieldResultArray extends AbstractStructArrayBase
{
    /**
     * The UpdateCustomFieldResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\UpdateCustomFieldResult[]
     */
    public $UpdateCustomFieldResult;
    /**
     * Constructor method for UpdateCustomFieldResultArray
     * @uses UpdateCustomFieldResultArray::setUpdateCustomFieldResult()
     * @param \StructType\UpdateCustomFieldResult[] $updateCustomFieldResult
     */
    public function __construct(array $updateCustomFieldResult = array())
    {
        $this
            ->setUpdateCustomFieldResult($updateCustomFieldResult);
    }
    /**
     * Get UpdateCustomFieldResult value
     * @return \StructType\UpdateCustomFieldResult[]|null
     */
    public function getUpdateCustomFieldResult()
    {
        return $this->UpdateCustomFieldResult;
    }
    /**
     * This method is responsible for validating the values passed to the setUpdateCustomFieldResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUpdateCustomFieldResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUpdateCustomFieldResultForArrayConstraintsFromSetUpdateCustomFieldResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $updateCustomFieldResultArrayUpdateCustomFieldResultItem) {
            // validation for constraint: itemType
            if (!$updateCustomFieldResultArrayUpdateCustomFieldResultItem instanceof \StructType\UpdateCustomFieldResult) {
                $invalidValues[] = is_object($updateCustomFieldResultArrayUpdateCustomFieldResultItem) ? get_class($updateCustomFieldResultArrayUpdateCustomFieldResultItem) : sprintf('%s(%s)', gettype($updateCustomFieldResultArrayUpdateCustomFieldResultItem), var_export($updateCustomFieldResultArrayUpdateCustomFieldResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UpdateCustomFieldResult property can only contain items of type \StructType\UpdateCustomFieldResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UpdateCustomFieldResult value
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateCustomFieldResult[] $updateCustomFieldResult
     * @return \ArrayType\UpdateCustomFieldResultArray
     */
    public function setUpdateCustomFieldResult(array $updateCustomFieldResult = array())
    {
        // validation for constraint: array
        if ('' !== ($updateCustomFieldResultArrayErrorMessage = self::validateUpdateCustomFieldResultForArrayConstraintsFromSetUpdateCustomFieldResult($updateCustomFieldResult))) {
            throw new \InvalidArgumentException($updateCustomFieldResultArrayErrorMessage, __LINE__);
        }
        $this->UpdateCustomFieldResult = $updateCustomFieldResult;
        return $this;
    }
    /**
     * Add item to UpdateCustomFieldResult value
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateCustomFieldResult $item
     * @return \ArrayType\UpdateCustomFieldResultArray
     */
    public function addToUpdateCustomFieldResult(\StructType\UpdateCustomFieldResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UpdateCustomFieldResult) {
            throw new \InvalidArgumentException(sprintf('The UpdateCustomFieldResult property can only contain items of type \StructType\UpdateCustomFieldResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UpdateCustomFieldResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UpdateCustomFieldResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UpdateCustomFieldResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UpdateCustomFieldResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UpdateCustomFieldResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UpdateCustomFieldResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UpdateCustomFieldResult
     */
    public function getAttributeName()
    {
        return 'UpdateCustomFieldResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\UpdateCustomFieldResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
