<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for UpdateEventParametersResultArray ArrayType
 * @subpackage Arrays
 */
class UpdateEventParametersResultArray extends AbstractStructArrayBase
{
    /**
     * The UpdateEventParametersResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\UpdateEventParametersResult[]
     */
    public $UpdateEventParametersResult;
    /**
     * Constructor method for UpdateEventParametersResultArray
     * @uses UpdateEventParametersResultArray::setUpdateEventParametersResult()
     * @param \StructType\UpdateEventParametersResult[] $updateEventParametersResult
     */
    public function __construct(array $updateEventParametersResult = array())
    {
        $this
            ->setUpdateEventParametersResult($updateEventParametersResult);
    }
    /**
     * Get UpdateEventParametersResult value
     * @return \StructType\UpdateEventParametersResult[]|null
     */
    public function getUpdateEventParametersResult()
    {
        return $this->UpdateEventParametersResult;
    }
    /**
     * This method is responsible for validating the values passed to the setUpdateEventParametersResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUpdateEventParametersResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUpdateEventParametersResultForArrayConstraintsFromSetUpdateEventParametersResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $updateEventParametersResultArrayUpdateEventParametersResultItem) {
            // validation for constraint: itemType
            if (!$updateEventParametersResultArrayUpdateEventParametersResultItem instanceof \StructType\UpdateEventParametersResult) {
                $invalidValues[] = is_object($updateEventParametersResultArrayUpdateEventParametersResultItem) ? get_class($updateEventParametersResultArrayUpdateEventParametersResultItem) : sprintf('%s(%s)', gettype($updateEventParametersResultArrayUpdateEventParametersResultItem), var_export($updateEventParametersResultArrayUpdateEventParametersResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UpdateEventParametersResult property can only contain items of type \StructType\UpdateEventParametersResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UpdateEventParametersResult value
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateEventParametersResult[] $updateEventParametersResult
     * @return \ArrayType\UpdateEventParametersResultArray
     */
    public function setUpdateEventParametersResult(array $updateEventParametersResult = array())
    {
        // validation for constraint: array
        if ('' !== ($updateEventParametersResultArrayErrorMessage = self::validateUpdateEventParametersResultForArrayConstraintsFromSetUpdateEventParametersResult($updateEventParametersResult))) {
            throw new \InvalidArgumentException($updateEventParametersResultArrayErrorMessage, __LINE__);
        }
        $this->UpdateEventParametersResult = $updateEventParametersResult;
        return $this;
    }
    /**
     * Add item to UpdateEventParametersResult value
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateEventParametersResult $item
     * @return \ArrayType\UpdateEventParametersResultArray
     */
    public function addToUpdateEventParametersResult(\StructType\UpdateEventParametersResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UpdateEventParametersResult) {
            throw new \InvalidArgumentException(sprintf('The UpdateEventParametersResult property can only contain items of type \StructType\UpdateEventParametersResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UpdateEventParametersResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UpdateEventParametersResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UpdateEventParametersResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UpdateEventParametersResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UpdateEventParametersResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UpdateEventParametersResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UpdateEventParametersResult
     */
    public function getAttributeName()
    {
        return 'UpdateEventParametersResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\UpdateEventParametersResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
