<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for UpdateGuestResultArray ArrayType
 * @subpackage Arrays
 */
class UpdateGuestResultArray extends AbstractStructArrayBase
{
    /**
     * The UpdateGuestResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\UpdateGuestResult[]
     */
    public $UpdateGuestResult;
    /**
     * Constructor method for UpdateGuestResultArray
     * @uses UpdateGuestResultArray::setUpdateGuestResult()
     * @param \StructType\UpdateGuestResult[] $updateGuestResult
     */
    public function __construct(array $updateGuestResult = array())
    {
        $this
            ->setUpdateGuestResult($updateGuestResult);
    }
    /**
     * Get UpdateGuestResult value
     * @return \StructType\UpdateGuestResult[]|null
     */
    public function getUpdateGuestResult()
    {
        return $this->UpdateGuestResult;
    }
    /**
     * This method is responsible for validating the values passed to the setUpdateGuestResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUpdateGuestResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUpdateGuestResultForArrayConstraintsFromSetUpdateGuestResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $updateGuestResultArrayUpdateGuestResultItem) {
            // validation for constraint: itemType
            if (!$updateGuestResultArrayUpdateGuestResultItem instanceof \StructType\UpdateGuestResult) {
                $invalidValues[] = is_object($updateGuestResultArrayUpdateGuestResultItem) ? get_class($updateGuestResultArrayUpdateGuestResultItem) : sprintf('%s(%s)', gettype($updateGuestResultArrayUpdateGuestResultItem), var_export($updateGuestResultArrayUpdateGuestResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UpdateGuestResult property can only contain items of type \StructType\UpdateGuestResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UpdateGuestResult value
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateGuestResult[] $updateGuestResult
     * @return \ArrayType\UpdateGuestResultArray
     */
    public function setUpdateGuestResult(array $updateGuestResult = array())
    {
        // validation for constraint: array
        if ('' !== ($updateGuestResultArrayErrorMessage = self::validateUpdateGuestResultForArrayConstraintsFromSetUpdateGuestResult($updateGuestResult))) {
            throw new \InvalidArgumentException($updateGuestResultArrayErrorMessage, __LINE__);
        }
        $this->UpdateGuestResult = $updateGuestResult;
        return $this;
    }
    /**
     * Add item to UpdateGuestResult value
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateGuestResult $item
     * @return \ArrayType\UpdateGuestResultArray
     */
    public function addToUpdateGuestResult(\StructType\UpdateGuestResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UpdateGuestResult) {
            throw new \InvalidArgumentException(sprintf('The UpdateGuestResult property can only contain items of type \StructType\UpdateGuestResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UpdateGuestResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UpdateGuestResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UpdateGuestResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UpdateGuestResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UpdateGuestResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UpdateGuestResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UpdateGuestResult
     */
    public function getAttributeName()
    {
        return 'UpdateGuestResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\UpdateGuestResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
