<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for UpdateInviteeInternalInfoResultArray ArrayType
 * @subpackage Arrays
 */
class UpdateInviteeInternalInfoResultArray extends AbstractStructArrayBase
{
    /**
     * The UpdateInviteeInternalInfoResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\UpdateInviteeInternalInfoResult[]
     */
    public $UpdateInviteeInternalInfoResult;
    /**
     * Constructor method for UpdateInviteeInternalInfoResultArray
     * @uses UpdateInviteeInternalInfoResultArray::setUpdateInviteeInternalInfoResult()
     * @param \StructType\UpdateInviteeInternalInfoResult[] $updateInviteeInternalInfoResult
     */
    public function __construct(array $updateInviteeInternalInfoResult = array())
    {
        $this
            ->setUpdateInviteeInternalInfoResult($updateInviteeInternalInfoResult);
    }
    /**
     * Get UpdateInviteeInternalInfoResult value
     * @return \StructType\UpdateInviteeInternalInfoResult[]|null
     */
    public function getUpdateInviteeInternalInfoResult()
    {
        return $this->UpdateInviteeInternalInfoResult;
    }
    /**
     * This method is responsible for validating the values passed to the setUpdateInviteeInternalInfoResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUpdateInviteeInternalInfoResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUpdateInviteeInternalInfoResultForArrayConstraintsFromSetUpdateInviteeInternalInfoResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $updateInviteeInternalInfoResultArrayUpdateInviteeInternalInfoResultItem) {
            // validation for constraint: itemType
            if (!$updateInviteeInternalInfoResultArrayUpdateInviteeInternalInfoResultItem instanceof \StructType\UpdateInviteeInternalInfoResult) {
                $invalidValues[] = is_object($updateInviteeInternalInfoResultArrayUpdateInviteeInternalInfoResultItem) ? get_class($updateInviteeInternalInfoResultArrayUpdateInviteeInternalInfoResultItem) : sprintf('%s(%s)', gettype($updateInviteeInternalInfoResultArrayUpdateInviteeInternalInfoResultItem), var_export($updateInviteeInternalInfoResultArrayUpdateInviteeInternalInfoResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UpdateInviteeInternalInfoResult property can only contain items of type \StructType\UpdateInviteeInternalInfoResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UpdateInviteeInternalInfoResult value
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateInviteeInternalInfoResult[] $updateInviteeInternalInfoResult
     * @return \ArrayType\UpdateInviteeInternalInfoResultArray
     */
    public function setUpdateInviteeInternalInfoResult(array $updateInviteeInternalInfoResult = array())
    {
        // validation for constraint: array
        if ('' !== ($updateInviteeInternalInfoResultArrayErrorMessage = self::validateUpdateInviteeInternalInfoResultForArrayConstraintsFromSetUpdateInviteeInternalInfoResult($updateInviteeInternalInfoResult))) {
            throw new \InvalidArgumentException($updateInviteeInternalInfoResultArrayErrorMessage, __LINE__);
        }
        $this->UpdateInviteeInternalInfoResult = $updateInviteeInternalInfoResult;
        return $this;
    }
    /**
     * Add item to UpdateInviteeInternalInfoResult value
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateInviteeInternalInfoResult $item
     * @return \ArrayType\UpdateInviteeInternalInfoResultArray
     */
    public function addToUpdateInviteeInternalInfoResult(\StructType\UpdateInviteeInternalInfoResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UpdateInviteeInternalInfoResult) {
            throw new \InvalidArgumentException(sprintf('The UpdateInviteeInternalInfoResult property can only contain items of type \StructType\UpdateInviteeInternalInfoResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UpdateInviteeInternalInfoResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UpdateInviteeInternalInfoResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UpdateInviteeInternalInfoResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UpdateInviteeInternalInfoResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UpdateInviteeInternalInfoResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UpdateInviteeInternalInfoResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UpdateInviteeInternalInfoResult
     */
    public function getAttributeName()
    {
        return 'UpdateInviteeInternalInfoResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\UpdateInviteeInternalInfoResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
