<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for UpdateSessionResultArray ArrayType
 * @subpackage Arrays
 */
class UpdateSessionResultArray extends AbstractStructArrayBase
{
    /**
     * The UpdateSessionResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\UpdateSessionResult[]
     */
    public $UpdateSessionResult;
    /**
     * Constructor method for UpdateSessionResultArray
     * @uses UpdateSessionResultArray::setUpdateSessionResult()
     * @param \StructType\UpdateSessionResult[] $updateSessionResult
     */
    public function __construct(array $updateSessionResult = array())
    {
        $this
            ->setUpdateSessionResult($updateSessionResult);
    }
    /**
     * Get UpdateSessionResult value
     * @return \StructType\UpdateSessionResult[]|null
     */
    public function getUpdateSessionResult()
    {
        return $this->UpdateSessionResult;
    }
    /**
     * This method is responsible for validating the values passed to the setUpdateSessionResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUpdateSessionResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUpdateSessionResultForArrayConstraintsFromSetUpdateSessionResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $updateSessionResultArrayUpdateSessionResultItem) {
            // validation for constraint: itemType
            if (!$updateSessionResultArrayUpdateSessionResultItem instanceof \StructType\UpdateSessionResult) {
                $invalidValues[] = is_object($updateSessionResultArrayUpdateSessionResultItem) ? get_class($updateSessionResultArrayUpdateSessionResultItem) : sprintf('%s(%s)', gettype($updateSessionResultArrayUpdateSessionResultItem), var_export($updateSessionResultArrayUpdateSessionResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UpdateSessionResult property can only contain items of type \StructType\UpdateSessionResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UpdateSessionResult value
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateSessionResult[] $updateSessionResult
     * @return \ArrayType\UpdateSessionResultArray
     */
    public function setUpdateSessionResult(array $updateSessionResult = array())
    {
        // validation for constraint: array
        if ('' !== ($updateSessionResultArrayErrorMessage = self::validateUpdateSessionResultForArrayConstraintsFromSetUpdateSessionResult($updateSessionResult))) {
            throw new \InvalidArgumentException($updateSessionResultArrayErrorMessage, __LINE__);
        }
        $this->UpdateSessionResult = $updateSessionResult;
        return $this;
    }
    /**
     * Add item to UpdateSessionResult value
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateSessionResult $item
     * @return \ArrayType\UpdateSessionResultArray
     */
    public function addToUpdateSessionResult(\StructType\UpdateSessionResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UpdateSessionResult) {
            throw new \InvalidArgumentException(sprintf('The UpdateSessionResult property can only contain items of type \StructType\UpdateSessionResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UpdateSessionResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UpdateSessionResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UpdateSessionResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UpdateSessionResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UpdateSessionResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UpdateSessionResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UpdateSessionResult
     */
    public function getAttributeName()
    {
        return 'UpdateSessionResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\UpdateSessionResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
