<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for UpdateUserResultArray ArrayType
 * @subpackage Arrays
 */
class UpdateUserResultArray extends AbstractStructArrayBase
{
    /**
     * The UpdateUserResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\UpdateUserResult[]
     */
    public $UpdateUserResult;
    /**
     * Constructor method for UpdateUserResultArray
     * @uses UpdateUserResultArray::setUpdateUserResult()
     * @param \StructType\UpdateUserResult[] $updateUserResult
     */
    public function __construct(array $updateUserResult = array())
    {
        $this
            ->setUpdateUserResult($updateUserResult);
    }
    /**
     * Get UpdateUserResult value
     * @return \StructType\UpdateUserResult[]|null
     */
    public function getUpdateUserResult()
    {
        return $this->UpdateUserResult;
    }
    /**
     * This method is responsible for validating the values passed to the setUpdateUserResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUpdateUserResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUpdateUserResultForArrayConstraintsFromSetUpdateUserResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $updateUserResultArrayUpdateUserResultItem) {
            // validation for constraint: itemType
            if (!$updateUserResultArrayUpdateUserResultItem instanceof \StructType\UpdateUserResult) {
                $invalidValues[] = is_object($updateUserResultArrayUpdateUserResultItem) ? get_class($updateUserResultArrayUpdateUserResultItem) : sprintf('%s(%s)', gettype($updateUserResultArrayUpdateUserResultItem), var_export($updateUserResultArrayUpdateUserResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UpdateUserResult property can only contain items of type \StructType\UpdateUserResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UpdateUserResult value
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateUserResult[] $updateUserResult
     * @return \ArrayType\UpdateUserResultArray
     */
    public function setUpdateUserResult(array $updateUserResult = array())
    {
        // validation for constraint: array
        if ('' !== ($updateUserResultArrayErrorMessage = self::validateUpdateUserResultForArrayConstraintsFromSetUpdateUserResult($updateUserResult))) {
            throw new \InvalidArgumentException($updateUserResultArrayErrorMessage, __LINE__);
        }
        $this->UpdateUserResult = $updateUserResult;
        return $this;
    }
    /**
     * Add item to UpdateUserResult value
     * @throws \InvalidArgumentException
     * @param \StructType\UpdateUserResult $item
     * @return \ArrayType\UpdateUserResultArray
     */
    public function addToUpdateUserResult(\StructType\UpdateUserResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UpdateUserResult) {
            throw new \InvalidArgumentException(sprintf('The UpdateUserResult property can only contain items of type \StructType\UpdateUserResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UpdateUserResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UpdateUserResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UpdateUserResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UpdateUserResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UpdateUserResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UpdateUserResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UpdateUserResult
     */
    public function getAttributeName()
    {
        return 'UpdateUserResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\UpdateUserResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
