<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for UpsertContactResultArray ArrayType
 * @subpackage Arrays
 */
class UpsertContactResultArray extends AbstractStructArrayBase
{
    /**
     * The UpsertContactResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\UpsertContactResult[]
     */
    public $UpsertContactResult;
    /**
     * Constructor method for UpsertContactResultArray
     * @uses UpsertContactResultArray::setUpsertContactResult()
     * @param \StructType\UpsertContactResult[] $upsertContactResult
     */
    public function __construct(array $upsertContactResult = array())
    {
        $this
            ->setUpsertContactResult($upsertContactResult);
    }
    /**
     * Get UpsertContactResult value
     * @return \StructType\UpsertContactResult[]|null
     */
    public function getUpsertContactResult()
    {
        return $this->UpsertContactResult;
    }
    /**
     * This method is responsible for validating the values passed to the setUpsertContactResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setUpsertContactResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateUpsertContactResultForArrayConstraintsFromSetUpsertContactResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $upsertContactResultArrayUpsertContactResultItem) {
            // validation for constraint: itemType
            if (!$upsertContactResultArrayUpsertContactResultItem instanceof \StructType\UpsertContactResult) {
                $invalidValues[] = is_object($upsertContactResultArrayUpsertContactResultItem) ? get_class($upsertContactResultArrayUpsertContactResultItem) : sprintf('%s(%s)', gettype($upsertContactResultArrayUpsertContactResultItem), var_export($upsertContactResultArrayUpsertContactResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The UpsertContactResult property can only contain items of type \StructType\UpsertContactResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set UpsertContactResult value
     * @throws \InvalidArgumentException
     * @param \StructType\UpsertContactResult[] $upsertContactResult
     * @return \ArrayType\UpsertContactResultArray
     */
    public function setUpsertContactResult(array $upsertContactResult = array())
    {
        // validation for constraint: array
        if ('' !== ($upsertContactResultArrayErrorMessage = self::validateUpsertContactResultForArrayConstraintsFromSetUpsertContactResult($upsertContactResult))) {
            throw new \InvalidArgumentException($upsertContactResultArrayErrorMessage, __LINE__);
        }
        $this->UpsertContactResult = $upsertContactResult;
        return $this;
    }
    /**
     * Add item to UpsertContactResult value
     * @throws \InvalidArgumentException
     * @param \StructType\UpsertContactResult $item
     * @return \ArrayType\UpsertContactResultArray
     */
    public function addToUpsertContactResult(\StructType\UpsertContactResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\UpsertContactResult) {
            throw new \InvalidArgumentException(sprintf('The UpsertContactResult property can only contain items of type \StructType\UpsertContactResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->UpsertContactResult[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\UpsertContactResult|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\UpsertContactResult|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\UpsertContactResult|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\UpsertContactResult|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\UpsertContactResult|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string UpsertContactResult
     */
    public function getAttributeName()
    {
        return 'UpsertContactResult';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\UpsertContactResultArray
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
