<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'Retrieve' => '\\StructType\\Retrieve',
            'RetrieveResponse' => '\\StructType\\RetrieveResponse',
            'CventSessionHeader' => '\\StructType\\CventSessionHeader',
            'GetUpdated' => '\\StructType\\GetUpdated',
            'GetUpdatedResponse' => '\\StructType\\GetUpdatedResponse',
            'GetDeleted' => '\\StructType\\GetDeleted',
            'GetDeletedResponse' => '\\StructType\\GetDeletedResponse',
            'Search' => '\\StructType\\Search',
            'SearchResponse' => '\\StructType\\SearchResponse',
            'DescribeGlobal' => '\\StructType\\DescribeGlobal',
            'DescribeGlobalResponse' => '\\StructType\\DescribeGlobalResponse',
            'DescribeCvObject' => '\\StructType\\DescribeCvObject',
            'DescribeCvObjectResponse' => '\\StructType\\DescribeCvObjectResponse',
            'Login' => '\\StructType\\Login',
            'LoginResponse' => '\\StructType\\LoginResponse',
            'CreateContact' => '\\StructType\\CreateContact',
            'ArrayOfContact' => '\\ArrayType\\ArrayOfContact',
            'CreateContactResponse' => '\\StructType\\CreateContactResponse',
            'UpdateContact' => '\\StructType\\UpdateContact',
            'UpdateContactResponse' => '\\StructType\\UpdateContactResponse',
            'UpsertContact' => '\\StructType\\UpsertContact',
            'UpsertContactResponse' => '\\StructType\\UpsertContactResponse',
            'UpdateInviteeInternalInfo' => '\\StructType\\UpdateInviteeInternalInfo',
            'ArrayOfCvAnswer' => '\\ArrayType\\ArrayOfCvAnswer',
            'UpdateInviteeInternalInfoResponse' => '\\StructType\\UpdateInviteeInternalInfoResponse',
            'DeleteContact' => '\\StructType\\DeleteContact',
            'ArrayOfCvObject' => '\\ArrayType\\ArrayOfCvObject',
            'DeleteContactResponse' => '\\StructType\\DeleteContactResponse',
            'ManageContactGroupMembers' => '\\StructType\\ManageContactGroupMembers',
            'ManageContactGroupMembersResponse' => '\\StructType\\ManageContactGroupMembersResponse',
            'ManageDistributionListMembers' => '\\StructType\\ManageDistributionListMembers',
            'ManageDistributionListMembersResponse' => '\\StructType\\ManageDistributionListMembersResponse',
            'CreateContactGroup' => '\\StructType\\CreateContactGroup',
            'ArrayOfContactGroup' => '\\ArrayType\\ArrayOfContactGroup',
            'CreateContactGroupResponse' => '\\StructType\\CreateContactGroupResponse',
            'CreateDistributionList' => '\\StructType\\CreateDistributionList',
            'ArrayOfDistributionList' => '\\ArrayType\\ArrayOfDistributionList',
            'CreateDistributionListResponse' => '\\StructType\\CreateDistributionListResponse',
            'CreateApprover' => '\\StructType\\CreateApprover',
            'ArrayOfApprover' => '\\ArrayType\\ArrayOfApprover',
            'CreateApproverResponse' => '\\StructType\\CreateApproverResponse',
            'DeleteApprover' => '\\StructType\\DeleteApprover',
            'ArrayOfDeleteApprover' => '\\ArrayType\\ArrayOfDeleteApprover',
            'DeleteApproverResponse' => '\\StructType\\DeleteApproverResponse',
            'UpdateApprover' => '\\StructType\\UpdateApprover',
            'UpdateApproverResponse' => '\\StructType\\UpdateApproverResponse',
            'CreateBudgetItem' => '\\StructType\\CreateBudgetItem',
            'ArrayOfBudgetItem' => '\\ArrayType\\ArrayOfBudgetItem',
            'CreateBudgetItemResponse' => '\\StructType\\CreateBudgetItemResponse',
            'DeleteBudgetItem' => '\\StructType\\DeleteBudgetItem',
            'DeleteBudgetItemResponse' => '\\StructType\\DeleteBudgetItemResponse',
            'TransferInvitee' => '\\StructType\\TransferInvitee',
            'TransferInviteeResponse' => '\\StructType\\TransferInviteeResponse',
            'CheckIn' => '\\StructType\\CheckIn',
            'CheckInResponse' => '\\StructType\\CheckInResponse',
            'SimpleEventRegistration' => '\\StructType\\SimpleEventRegistration',
            'SimpleEventRegistrationResponse' => '\\StructType\\SimpleEventRegistrationResponse',
            'SendEmail' => '\\StructType\\SendEmail',
            'SendEmailResponse' => '\\StructType\\SendEmailResponse',
            'CreateUser' => '\\StructType\\CreateUser',
            'ArrayOfUser' => '\\ArrayType\\ArrayOfUser',
            'CreateUserResponse' => '\\StructType\\CreateUserResponse',
            'CreateSurveyAnswer' => '\\StructType\\CreateSurveyAnswer',
            'CreateSurveyAnswerResponse' => '\\StructType\\CreateSurveyAnswerResponse',
            'CreatePostEventFeedback' => '\\StructType\\CreatePostEventFeedback',
            'CreatePostEventFeedbackResponse' => '\\StructType\\CreatePostEventFeedbackResponse',
            'UpdateUser' => '\\StructType\\UpdateUser',
            'UpdateUserResponse' => '\\StructType\\UpdateUserResponse',
            'DeleteUser' => '\\StructType\\DeleteUser',
            'DeleteUserResponse' => '\\StructType\\DeleteUserResponse',
            'ManageUserGroup' => '\\StructType\\ManageUserGroup',
            'ManageUserGroupResponse' => '\\StructType\\ManageUserGroupResponse',
            'CreateNoRegEvent' => '\\StructType\\CreateNoRegEvent',
            'ArrayOfEventParameters' => '\\ArrayType\\ArrayOfEventParameters',
            'CreateNoRegEventResponse' => '\\StructType\\CreateNoRegEventResponse',
            'CopyEvent' => '\\StructType\\CopyEvent',
            'CopyEventResponse' => '\\StructType\\CopyEventResponse',
            'CreateRateHistory' => '\\StructType\\CreateRateHistory',
            'ArrayOfRateHistory' => '\\ArrayType\\ArrayOfRateHistory',
            'CreateRateHistoryResponse' => '\\StructType\\CreateRateHistoryResponse',
            'DeleteRateHistory' => '\\StructType\\DeleteRateHistory',
            'DeleteRateHistoryResponse' => '\\StructType\\DeleteRateHistoryResponse',
            'CreateTransaction' => '\\StructType\\CreateTransaction',
            'ArrayOfTransaction' => '\\ArrayType\\ArrayOfTransaction',
            'CreateTransactionResponse' => '\\StructType\\CreateTransactionResponse',
            'CreateRFP' => '\\StructType\\CreateRFP',
            'ArrayOfRFPParameters' => '\\ArrayType\\ArrayOfRFPParameters',
            'CreateRFPResponse' => '\\StructType\\CreateRFPResponse',
            'ValidateInvitee' => '\\StructType\\ValidateInvitee',
            'ArrayOfCvInvitee' => '\\ArrayType\\ArrayOfCvInvitee',
            'ValidateInviteeResponse' => '\\StructType\\ValidateInviteeResponse',
            'SessionRegAction' => '\\StructType\\SessionRegAction',
            'SessionRegActionResponse' => '\\StructType\\SessionRegActionResponse',
            'CreateConversionRate' => '\\StructType\\CreateConversionRate',
            'ArrayOfCvConversionRate' => '\\ArrayType\\ArrayOfCvConversionRate',
            'CreateConversionRateResponse' => '\\StructType\\CreateConversionRateResponse',
            'DeleteConversionRate' => '\\StructType\\DeleteConversionRate',
            'DeleteConversionRateResponse' => '\\StructType\\DeleteConversionRateResponse',
            'CreateSession' => '\\StructType\\CreateSession',
            'ArrayOfSession' => '\\ArrayType\\ArrayOfSession',
            'CreateSessionResponse' => '\\StructType\\CreateSessionResponse',
            'UpdateSession' => '\\StructType\\UpdateSession',
            'UpdateSessionResponse' => '\\StructType\\UpdateSessionResponse',
            'UpdateEventParameters' => '\\StructType\\UpdateEventParameters',
            'UpdateEventParametersResponse' => '\\StructType\\UpdateEventParametersResponse',
            'CreateMeetingRequest' => '\\StructType\\CreateMeetingRequest',
            'ArrayOfMeetingRequest' => '\\ArrayType\\ArrayOfMeetingRequest',
            'CreateMeetingRequestResponse' => '\\StructType\\CreateMeetingRequestResponse',
            'UpdateMeetingRequest' => '\\StructType\\UpdateMeetingRequest',
            'UpdateMeetingRequestResponse' => '\\StructType\\UpdateMeetingRequestResponse',
            'CreateCustomField' => '\\StructType\\CreateCustomField',
            'ArrayOfEntityCustomField' => '\\ArrayType\\ArrayOfEntityCustomField',
            'CreateCustomFieldResponse' => '\\StructType\\CreateCustomFieldResponse',
            'UpdateCustomField' => '\\StructType\\UpdateCustomField',
            'UpdateCustomFieldResponse' => '\\StructType\\UpdateCustomFieldResponse',
            'AddAdvancedLogic' => '\\StructType\\AddAdvancedLogic',
            'ArrayOfAdvancedLogic' => '\\ArrayType\\ArrayOfAdvancedLogic',
            'AddAdvancedLogicResponse' => '\\StructType\\AddAdvancedLogicResponse',
            'UpdateRegistrationType' => '\\StructType\\UpdateRegistrationType',
            'ArrayOfRegistration' => '\\ArrayType\\ArrayOfRegistration',
            'UpdateRegistrationTypeResponse' => '\\StructType\\UpdateRegistrationTypeResponse',
            'UpdateGuestInfo' => '\\StructType\\UpdateGuestInfo',
            'ArrayOfGuest' => '\\ArrayType\\ArrayOfGuest',
            'UpdateGuestInfoResponse' => '\\StructType\\UpdateGuestInfoResponse',
            'IdArray' => '\\ArrayType\\IdArray',
            'RetrieveResult' => '\\StructType\\RetrieveResult',
            'CvObject' => '\\StructType\\CvObject',
            'Contact' => '\\StructType\\Contact',
            'CustomFieldDetail' => '\\StructType\\CustomFieldDetail',
            'ContactGroupDetail' => '\\StructType\\ContactGroupDetail',
            'DistributionListDetail' => '\\StructType\\DistributionListDetail',
            'ContactGroup' => '\\StructType\\ContactGroup',
            'User' => '\\StructType\\User',
            'UserGroupDetail' => '\\StructType\\UserGroupDetail',
            'VisibilityDefaults' => '\\StructType\\VisibilityDefaults',
            'MeetingRequestUser' => '\\StructType\\MeetingRequestUser',
            'MeetingRequest' => '\\StructType\\MeetingRequest',
            'EventRequestInfo' => '\\StructType\\EventRequestInfo',
            'RFPRequestInfo' => '\\StructType\\RFPRequestInfo',
            'RFPRequestInfoMeetingRoomAvailabilityDetail' => '\\StructType\\RFPRequestInfoMeetingRoomAvailabilityDetail',
            'RFPRequestInfoSleepingRoomAvailabilityDetail' => '\\StructType\\RFPRequestInfoSleepingRoomAvailabilityDetail',
            'DocumentDetail' => '\\StructType\\DocumentDetail',
            'EventSurveyDetail' => '\\StructType\\EventSurveyDetail',
            'EventAnswer' => '\\StructType\\EventAnswer',
            'EntityCustomField' => '\\StructType\\EntityCustomField',
            'FieldChoice' => '\\StructType\\FieldChoice',
            'AdvancedLogic' => '\\StructType\\AdvancedLogic',
            'AdvancedLogicChoices' => '\\StructType\\AdvancedLogicChoices',
            'UserGroup' => '\\StructType\\UserGroup',
            'UserRole' => '\\StructType\\UserRole',
            'UserRights' => '\\StructType\\UserRights',
            'CvAnswer' => '\\StructType\\CvAnswer',
            'Survey' => '\\StructType\\Survey',
            'WeblinkDetail' => '\\StructType\\WeblinkDetail',
            'TargetListDetail' => '\\StructType\\TargetListDetail',
            'AssociatedEvents' => '\\StructType\\AssociatedEvents',
            'Respondent' => '\\StructType\\Respondent',
            'Response' => '\\StructType\\Response',
            'ResponseSurveyDetail' => '\\StructType\\ResponseSurveyDetail',
            'SurveyDetail' => '\\StructType\\SurveyDetail',
            'Answer' => '\\StructType\\Answer',
            'SurveyEmailHistory' => '\\StructType\\SurveyEmailHistory',
            'SurveyQuestion' => '\\StructType\\SurveyQuestion',
            'AnswerDetail' => '\\StructType\\AnswerDetail',
            'RowDetail' => '\\StructType\\RowDetail',
            'RFP' => '\\StructType\\RFP',
            'RFPEventInfo' => '\\StructType\\RFPEventInfo',
            'BaseRFPEventInfo' => '\\StructType\\BaseRFPEventInfo',
            'SupplierRFPEventInfo' => '\\StructType\\SupplierRFPEventInfo',
            'SupplierRFPEventHistoryDetail' => '\\StructType\\SupplierRFPEventHistoryDetail',
            'BaseRFPEventHistoryDetail' => '\\StructType\\BaseRFPEventHistoryDetail',
            'RFPEventHistoryDetail' => '\\StructType\\RFPEventHistoryDetail',
            'RFPAlternateDate' => '\\StructType\\RFPAlternateDate',
            'AlternateDates' => '\\StructType\\AlternateDates',
            'RFPOrganizationInfo' => '\\StructType\\RFPOrganizationInfo',
            'RFPKeyContactInfo' => '\\StructType\\RFPKeyContactInfo',
            'KeyContactInfo' => '\\StructType\\KeyContactInfo',
            'ProposalKeyContactInfo' => '\\StructType\\ProposalKeyContactInfo',
            'RFPEventRequirementInfo' => '\\StructType\\RFPEventRequirementInfo',
            'RFPMeetingRoomDetail' => '\\StructType\\RFPMeetingRoomDetail',
            'RFPSleepRoomInfo' => '\\StructType\\RFPSleepRoomInfo',
            'RFPSleepRoomDetail' => '\\StructType\\RFPSleepRoomDetail',
            'RFPOccupancyPerRoomDetail' => '\\StructType\\RFPOccupancyPerRoomDetail',
            'RFPAttachmentDetail' => '\\StructType\\RFPAttachmentDetail',
            'AttachmentDetail' => '\\StructType\\AttachmentDetail',
            'ProposalAttachmentDetail' => '\\StructType\\ProposalAttachmentDetail',
            'RFPQuestionDetail' => '\\StructType\\RFPQuestionDetail',
            'ProposalSurveyDetail' => '\\StructType\\ProposalSurveyDetail',
            'ProposalAnswer' => '\\StructType\\ProposalAnswer',
            'RFPDinnerInfo' => '\\StructType\\RFPDinnerInfo',
            'RFPSupplierDetail' => '\\StructType\\RFPSupplierDetail',
            'SupplierDetail' => '\\StructType\\SupplierDetail',
            'SupplierRFPInfoDetail' => '\\StructType\\SupplierRFPInfoDetail',
            'ContractedDataDetail' => '\\StructType\\ContractedDataDetail',
            'SleepingRoomDetail' => '\\StructType\\SleepingRoomDetail',
            'UserDetail' => '\\StructType\\UserDetail',
            'SupplierRFP' => '\\StructType\\SupplierRFP',
            'SupplierRFPRecipientDetail' => '\\StructType\\SupplierRFPRecipientDetail',
            'SupplierRFPForwardHistoryDetail' => '\\StructType\\SupplierRFPForwardHistoryDetail',
            'SupplierRFPAssignmentHistoryDetail' => '\\StructType\\SupplierRFPAssignmentHistoryDetail',
            'Proposal' => '\\StructType\\Proposal',
            'ProposalVenueInfo' => '\\StructType\\ProposalVenueInfo',
            'ProposalEventInfo' => '\\StructType\\ProposalEventInfo',
            'ProposalSleepRoomInfo' => '\\StructType\\ProposalSleepRoomInfo',
            'ProposalSleepRoomAvailabilityDetail' => '\\StructType\\ProposalSleepRoomAvailabilityDetail',
            'ProposalAdditionalFeeDetail' => '\\StructType\\ProposalAdditionalFeeDetail',
            'ProposalEventRequirementsInfo' => '\\StructType\\ProposalEventRequirementsInfo',
            'ProposalMeetingRoomAvailabilityDetail' => '\\StructType\\ProposalMeetingRoomAvailabilityDetail',
            'ProposalEstimatedCostDetail' => '\\StructType\\ProposalEstimatedCostDetail',
            'ProposalPackagePricingDetail' => '\\StructType\\ProposalPackagePricingDetail',
            'ConventionCenterInformation' => '\\StructType\\ConventionCenterInformation',
            'ProposalEventSpaceInfo' => '\\StructType\\ProposalEventSpaceInfo',
            'ProposalEventSpace' => '\\StructType\\ProposalEventSpace',
            'ProposalAlternateDateInfo' => '\\StructType\\ProposalAlternateDateInfo',
            'ProposalAlternateDate' => '\\StructType\\ProposalAlternateDate',
            'SupplierProposal' => '\\StructType\\SupplierProposal',
            'SupplierProposalVenueInfo' => '\\StructType\\SupplierProposalVenueInfo',
            'RateHistory' => '\\StructType\\RateHistory',
            'Supplier' => '\\StructType\\Supplier',
            'SupplierImageDetail' => '\\StructType\\SupplierImageDetail',
            'SupplierRateHistoryDetail' => '\\StructType\\SupplierRateHistoryDetail',
            'SupplierExternalIdDetail' => '\\StructType\\SupplierExternalIdDetail',
            'RFPParameters' => '\\StructType\\RFPParameters',
            'Event' => '\\StructType\\Event',
            'ProductDetail' => '\\StructType\\ProductDetail',
            'Invitee' => '\\StructType\\Invitee',
            'InternalInfoDetail' => '\\StructType\\InternalInfoDetail',
            'RegretSurveyDetail' => '\\StructType\\RegretSurveyDetail',
            'Guest' => '\\StructType\\Guest',
            'Registration' => '\\StructType\\Registration',
            'GuestDetail' => '\\StructType\\GuestDetail',
            'OrderDetail' => '\\StructType\\OrderDetail',
            'DiscountDetail' => '\\StructType\\DiscountDetail',
            'PaymentDetail' => '\\StructType\\PaymentDetail',
            'Transaction' => '\\StructType\\Transaction',
            'DistributionDetail' => '\\StructType\\DistributionDetail',
            'GLCodes' => '\\StructType\\GLCodes',
            'EventEmailHistory' => '\\StructType\\EventEmailHistory',
            'Appointment' => '\\StructType\\Appointment',
            'AppointmentAttendee' => '\\StructType\\AppointmentAttendee',
            'Session' => '\\StructType\\Session',
            'HotelRequest' => '\\StructType\\HotelRequest',
            'TravelSurveyDetail' => '\\StructType\\TravelSurveyDetail',
            'TravelAnswer' => '\\StructType\\TravelAnswer',
            'HotelRoomRate' => '\\StructType\\HotelRoomRate',
            'Travel' => '\\StructType\\Travel',
            'CarRequest' => '\\StructType\\CarRequest',
            'AirRequest' => '\\StructType\\AirRequest',
            'AirActual' => '\\StructType\\AirActual',
            'FlightDetail' => '\\StructType\\FlightDetail',
            'Budget' => '\\StructType\\Budget',
            'CategoryDetail' => '\\StructType\\CategoryDetail',
            'AmountDetail' => '\\StructType\\AmountDetail',
            'TaxDetail' => '\\StructType\\TaxDetail',
            'TableAssignment' => '\\StructType\\TableAssignment',
            'BudgetItem' => '\\StructType\\BudgetItem',
            'CostDetail' => '\\StructType\\CostDetail',
            'SavingsDetail' => '\\StructType\\SavingsDetail',
            'BudgetPaymentDetail' => '\\StructType\\BudgetPaymentDetail',
            'AllocationCategoryDetail' => '\\StructType\\AllocationCategoryDetail',
            'AssociatedRegistrants' => '\\StructType\\AssociatedRegistrants',
            'EventCards' => '\\StructType\\EventCards',
            'ClientDefinedDetail' => '\\StructType\\ClientDefinedDetail',
            'EventParameters' => '\\StructType\\EventParameters',
            'EventQuestion' => '\\StructType\\EventQuestion',
            'EventDetail' => '\\StructType\\EventDetail',
            'PlanningStatusHistory' => '\\StructType\\PlanningStatusHistory',
            'ProcessFormDetail' => '\\StructType\\ProcessFormDetail',
            'EventRoleDetail' => '\\StructType\\EventRoleDetail',
            'FAQDetail' => '\\StructType\\FAQDetail',
            'StaffDetail' => '\\StructType\\StaffDetail',
            'Fees' => '\\StructType\\Fees',
            'SessionRegInvitee' => '\\StructType\\SessionRegInvitee',
            'CvInvitee' => '\\StructType\\CvInvitee',
            'Speaker' => '\\StructType\\Speaker',
            'RelatedWebsitesDetail' => '\\StructType\\RelatedWebsitesDetail',
            'AssignedSessions' => '\\StructType\\AssignedSessions',
            'CvConversionRate' => '\\StructType\\CvConversionRate',
            'Campaign' => '\\StructType\\Campaign',
            'DistributionList' => '\\StructType\\DistributionList',
            'EMarketingEmailHistory' => '\\StructType\\EMarketingEmailHistory',
            'Approver' => '\\StructType\\Approver',
            'GetUpdatedResult' => '\\StructType\\GetUpdatedResult',
            'GetDeletedResult' => '\\StructType\\GetDeletedResult',
            'CvSearch' => '\\StructType\\CvSearch',
            'Filter' => '\\StructType\\Filter',
            'ArrayOfString' => '\\ArrayType\\ArrayOfString',
            'SearchResult' => '\\StructType\\SearchResult',
            'DescribeGlobalResult' => '\\StructType\\DescribeGlobalResult',
            'ArrayOfLookUp' => '\\ArrayType\\ArrayOfLookUp',
            'LookUp' => '\\StructType\\LookUp',
            'CvObjectTypeArray' => '\\ArrayType\\CvObjectTypeArray',
            'DescribeCvObjectResults' => '\\StructType\\DescribeCvObjectResults',
            'DescribeCvObjectResult' => '\\StructType\\DescribeCvObjectResult',
            'Field' => '\\StructType\\Field',
            'LookUpDetail' => '\\StructType\\LookUpDetail',
            'CustomField' => '\\StructType\\CustomField',
            'LoginResult' => '\\StructType\\LoginResult',
            'CreateContactResultArray' => '\\ArrayType\\CreateContactResultArray',
            'CreateContactResult' => '\\StructType\\CreateContactResult',
            'ArrayOfError' => '\\ArrayType\\ArrayOfError',
            'Error' => '\\StructType\\Error',
            'UpdateContactResultArray' => '\\ArrayType\\UpdateContactResultArray',
            'UpdateContactResult' => '\\StructType\\UpdateContactResult',
            'UpsertContactResultArray' => '\\ArrayType\\UpsertContactResultArray',
            'UpsertContactResult' => '\\StructType\\UpsertContactResult',
            'UpdateInviteeInternalInfoResultArray' => '\\ArrayType\\UpdateInviteeInternalInfoResultArray',
            'UpdateInviteeInternalInfoResult' => '\\StructType\\UpdateInviteeInternalInfoResult',
            'DeleteContactResultArray' => '\\ArrayType\\DeleteContactResultArray',
            'DeleteContactResult' => '\\StructType\\DeleteContactResult',
            'CvObjectArray' => '\\ArrayType\\CvObjectArray',
            'ManageContactGroupMembersResultArray' => '\\ArrayType\\ManageContactGroupMembersResultArray',
            'ManageContactGroupResult' => '\\StructType\\ManageContactGroupResult',
            'ManageDistributionListMembersResultArray' => '\\ArrayType\\ManageDistributionListMembersResultArray',
            'ManageDistributionListResult' => '\\StructType\\ManageDistributionListResult',
            'CreateContactGroupResultArray' => '\\ArrayType\\CreateContactGroupResultArray',
            'CreateContactGroupResult' => '\\StructType\\CreateContactGroupResult',
            'CreateDistributionListResultArray' => '\\ArrayType\\CreateDistributionListResultArray',
            'CreateDistributionListResult' => '\\StructType\\CreateDistributionListResult',
            'CreateApproverResultArray' => '\\ArrayType\\CreateApproverResultArray',
            'CreateApproverResult' => '\\StructType\\CreateApproverResult',
            'DeleteApproverResultArray' => '\\ArrayType\\DeleteApproverResultArray',
            'DeleteApproverResult' => '\\StructType\\DeleteApproverResult',
            'UpdateApproverResultArray' => '\\ArrayType\\UpdateApproverResultArray',
            'UpdateApproverResult' => '\\StructType\\UpdateApproverResult',
            'CreateBudgetItemResultArray' => '\\ArrayType\\CreateBudgetItemResultArray',
            'CreateBudgetItemResult' => '\\StructType\\CreateBudgetItemResult',
            'DeleteBudgetItemResultArray' => '\\ArrayType\\DeleteBudgetItemResultArray',
            'DeleteBudgetItemResult' => '\\StructType\\DeleteBudgetItemResult',
            'TransferInviteeResultArray' => '\\ArrayType\\TransferInviteeResultArray',
            'TransferInviteeResult' => '\\StructType\\TransferInviteeResult',
            'CheckInResultArray' => '\\ArrayType\\CheckInResultArray',
            'CheckInResult' => '\\StructType\\CheckInResult',
            'SimpleEventRegistrationResultArray' => '\\ArrayType\\SimpleEventRegistrationResultArray',
            'SimpleEventRegistrationResult' => '\\StructType\\SimpleEventRegistrationResult',
            'SendEmailRequest' => '\\StructType\\SendEmailRequest',
            'SendEmailResultArray' => '\\ArrayType\\SendEmailResultArray',
            'SendEmailResult' => '\\StructType\\SendEmailResult',
            'CreateUserResultArray' => '\\ArrayType\\CreateUserResultArray',
            'CreateUserResult' => '\\StructType\\CreateUserResult',
            'CreateSurveyAnswerResultArray' => '\\ArrayType\\CreateSurveyAnswerResultArray',
            'CreateSurveyAnswerResult' => '\\StructType\\CreateSurveyAnswerResult',
            'CreatePostEventFeedbackResultArray' => '\\ArrayType\\CreatePostEventFeedbackResultArray',
            'CreatePostEventFeedbackResult' => '\\StructType\\CreatePostEventFeedbackResult',
            'UpdateUserResultArray' => '\\ArrayType\\UpdateUserResultArray',
            'UpdateUserResult' => '\\StructType\\UpdateUserResult',
            'DeleteUserResultArray' => '\\ArrayType\\DeleteUserResultArray',
            'DeleteUserResult' => '\\StructType\\DeleteUserResult',
            'ManageUserGroupResultArray' => '\\ArrayType\\ManageUserGroupResultArray',
            'ManageUserGroupResult' => '\\StructType\\ManageUserGroupResult',
            'CreateNoRegEventResultArray' => '\\ArrayType\\CreateNoRegEventResultArray',
            'CreateNoRegEventResult' => '\\StructType\\CreateNoRegEventResult',
            'CopyEventResultArray' => '\\ArrayType\\CopyEventResultArray',
            'CopyEventResult' => '\\StructType\\CopyEventResult',
            'CreateRateHistoryResultArray' => '\\ArrayType\\CreateRateHistoryResultArray',
            'CreateRateHistoryResult' => '\\StructType\\CreateRateHistoryResult',
            'DeleteRateHistoryResultArray' => '\\ArrayType\\DeleteRateHistoryResultArray',
            'DeleteRateHistoryResult' => '\\StructType\\DeleteRateHistoryResult',
            'CreateTransactionResultArray' => '\\ArrayType\\CreateTransactionResultArray',
            'CreateTransactionResult' => '\\StructType\\CreateTransactionResult',
            'CreateRFPResultArray' => '\\ArrayType\\CreateRFPResultArray',
            'CreateRFPResult' => '\\StructType\\CreateRFPResult',
            'ValidateInviteeResultArray' => '\\ArrayType\\ValidateInviteeResultArray',
            'ValidateInviteeResult' => '\\StructType\\ValidateInviteeResult',
            'SessionRegActionResultArray' => '\\ArrayType\\SessionRegActionResultArray',
            'SessionRegActionResult' => '\\StructType\\SessionRegActionResult',
            'ConversionRateResultArray' => '\\ArrayType\\ConversionRateResultArray',
            'ConversionRateResult' => '\\StructType\\ConversionRateResult',
            'CreateSessionResultArray' => '\\ArrayType\\CreateSessionResultArray',
            'CreateSessionResult' => '\\StructType\\CreateSessionResult',
            'UpdateSessionResultArray' => '\\ArrayType\\UpdateSessionResultArray',
            'UpdateSessionResult' => '\\StructType\\UpdateSessionResult',
            'UpdateEventParametersResultArray' => '\\ArrayType\\UpdateEventParametersResultArray',
            'UpdateEventParametersResult' => '\\StructType\\UpdateEventParametersResult',
            'CreateMeetingRequestResultArray' => '\\ArrayType\\CreateMeetingRequestResultArray',
            'CreateMeetingRequestResult' => '\\StructType\\CreateMeetingRequestResult',
            'UpdateMeetingRequestResultArray' => '\\ArrayType\\UpdateMeetingRequestResultArray',
            'UpdateMeetingRequestResult' => '\\StructType\\UpdateMeetingRequestResult',
            'CreateCustomFieldResultArray' => '\\ArrayType\\CreateCustomFieldResultArray',
            'CreateCustomFieldResult' => '\\StructType\\CreateCustomFieldResult',
            'UpdateCustomFieldResultArray' => '\\ArrayType\\UpdateCustomFieldResultArray',
            'UpdateCustomFieldResult' => '\\StructType\\UpdateCustomFieldResult',
            'AddAdvancedLogicResultArray' => '\\ArrayType\\AddAdvancedLogicResultArray',
            'AddAdvancedLogicResult' => '\\StructType\\AddAdvancedLogicResult',
            'UpdateRegTypeResultArray' => '\\ArrayType\\UpdateRegTypeResultArray',
            'UpdateRegTypeResult' => '\\StructType\\UpdateRegTypeResult',
            'UpdateGuestResultArray' => '\\ArrayType\\UpdateGuestResultArray',
            'UpdateGuestResult' => '\\StructType\\UpdateGuestResult',
        );
    }
}
