<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for AdvancedLogic StructType
 * @subpackage Structs
 */
class AdvancedLogic extends CvObject
{
    /**
     * The AdvancedLogicChoices
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\AdvancedLogicChoices[]
     */
    public $AdvancedLogicChoices;
    /**
     * The SourceField
     * @var string
     */
    public $SourceField;
    /**
     * Constructor method for AdvancedLogic
     * @uses AdvancedLogic::setAdvancedLogicChoices()
     * @uses AdvancedLogic::setSourceField()
     * @param \StructType\AdvancedLogicChoices[] $advancedLogicChoices
     * @param string $sourceField
     */
    public function __construct(array $advancedLogicChoices = array(), $sourceField = null)
    {
        $this
            ->setAdvancedLogicChoices($advancedLogicChoices)
            ->setSourceField($sourceField);
    }
    /**
     * Get AdvancedLogicChoices value
     * @return \StructType\AdvancedLogicChoices[]|null
     */
    public function getAdvancedLogicChoices()
    {
        return $this->AdvancedLogicChoices;
    }
    /**
     * This method is responsible for validating the values passed to the setAdvancedLogicChoices method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAdvancedLogicChoices method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAdvancedLogicChoicesForArrayConstraintsFromSetAdvancedLogicChoices(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $advancedLogicAdvancedLogicChoicesItem) {
            // validation for constraint: itemType
            if (!$advancedLogicAdvancedLogicChoicesItem instanceof \StructType\AdvancedLogicChoices) {
                $invalidValues[] = is_object($advancedLogicAdvancedLogicChoicesItem) ? get_class($advancedLogicAdvancedLogicChoicesItem) : sprintf('%s(%s)', gettype($advancedLogicAdvancedLogicChoicesItem), var_export($advancedLogicAdvancedLogicChoicesItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The AdvancedLogicChoices property can only contain items of type \StructType\AdvancedLogicChoices, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set AdvancedLogicChoices value
     * @throws \InvalidArgumentException
     * @param \StructType\AdvancedLogicChoices[] $advancedLogicChoices
     * @return \StructType\AdvancedLogic
     */
    public function setAdvancedLogicChoices(array $advancedLogicChoices = array())
    {
        // validation for constraint: array
        if ('' !== ($advancedLogicChoicesArrayErrorMessage = self::validateAdvancedLogicChoicesForArrayConstraintsFromSetAdvancedLogicChoices($advancedLogicChoices))) {
            throw new \InvalidArgumentException($advancedLogicChoicesArrayErrorMessage, __LINE__);
        }
        $this->AdvancedLogicChoices = $advancedLogicChoices;
        return $this;
    }
    /**
     * Add item to AdvancedLogicChoices value
     * @throws \InvalidArgumentException
     * @param \StructType\AdvancedLogicChoices $item
     * @return \StructType\AdvancedLogic
     */
    public function addToAdvancedLogicChoices(\StructType\AdvancedLogicChoices $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\AdvancedLogicChoices) {
            throw new \InvalidArgumentException(sprintf('The AdvancedLogicChoices property can only contain items of type \StructType\AdvancedLogicChoices, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->AdvancedLogicChoices[] = $item;
        return $this;
    }
    /**
     * Get SourceField value
     * @return string|null
     */
    public function getSourceField()
    {
        return $this->SourceField;
    }
    /**
     * Set SourceField value
     * @param string $sourceField
     * @return \StructType\AdvancedLogic
     */
    public function setSourceField($sourceField = null)
    {
        // validation for constraint: string
        if (!is_null($sourceField) && !is_string($sourceField)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($sourceField, true), gettype($sourceField)), __LINE__);
        }
        $this->SourceField = $sourceField;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\AdvancedLogic
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
