<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Answer StructType
 * @subpackage Structs
 */
class Answer extends AbstractStructBase
{
    /**
     * The AnswerPart
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $AnswerPart;
    /**
     * The AnswerColumn
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $AnswerColumn;
    /**
     * The AnswerText
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $AnswerText;
    /**
     * The AnswerOther
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $AnswerOther;
    /**
     * The AnswerExportValue
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $AnswerExportValue;
    /**
     * The AnswerComment
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $AnswerComment;
    /**
     * Constructor method for Answer
     * @uses Answer::setAnswerPart()
     * @uses Answer::setAnswerColumn()
     * @uses Answer::setAnswerText()
     * @uses Answer::setAnswerOther()
     * @uses Answer::setAnswerExportValue()
     * @uses Answer::setAnswerComment()
     * @param string $answerPart
     * @param string $answerColumn
     * @param string $answerText
     * @param string $answerOther
     * @param string $answerExportValue
     * @param string $answerComment
     */
    public function __construct($answerPart = null, $answerColumn = null, $answerText = null, $answerOther = null, $answerExportValue = null, $answerComment = null)
    {
        $this
            ->setAnswerPart($answerPart)
            ->setAnswerColumn($answerColumn)
            ->setAnswerText($answerText)
            ->setAnswerOther($answerOther)
            ->setAnswerExportValue($answerExportValue)
            ->setAnswerComment($answerComment);
    }
    /**
     * Get AnswerPart value
     * @return string
     */
    public function getAnswerPart()
    {
        return $this->AnswerPart;
    }
    /**
     * Set AnswerPart value
     * @param string $answerPart
     * @return \StructType\Answer
     */
    public function setAnswerPart($answerPart = null)
    {
        // validation for constraint: string
        if (!is_null($answerPart) && !is_string($answerPart)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($answerPart, true), gettype($answerPart)), __LINE__);
        }
        $this->AnswerPart = $answerPart;
        return $this;
    }
    /**
     * Get AnswerColumn value
     * @return string
     */
    public function getAnswerColumn()
    {
        return $this->AnswerColumn;
    }
    /**
     * Set AnswerColumn value
     * @param string $answerColumn
     * @return \StructType\Answer
     */
    public function setAnswerColumn($answerColumn = null)
    {
        // validation for constraint: string
        if (!is_null($answerColumn) && !is_string($answerColumn)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($answerColumn, true), gettype($answerColumn)), __LINE__);
        }
        $this->AnswerColumn = $answerColumn;
        return $this;
    }
    /**
     * Get AnswerText value
     * @return string
     */
    public function getAnswerText()
    {
        return $this->AnswerText;
    }
    /**
     * Set AnswerText value
     * @param string $answerText
     * @return \StructType\Answer
     */
    public function setAnswerText($answerText = null)
    {
        // validation for constraint: string
        if (!is_null($answerText) && !is_string($answerText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($answerText, true), gettype($answerText)), __LINE__);
        }
        $this->AnswerText = $answerText;
        return $this;
    }
    /**
     * Get AnswerOther value
     * @return string
     */
    public function getAnswerOther()
    {
        return $this->AnswerOther;
    }
    /**
     * Set AnswerOther value
     * @param string $answerOther
     * @return \StructType\Answer
     */
    public function setAnswerOther($answerOther = null)
    {
        // validation for constraint: string
        if (!is_null($answerOther) && !is_string($answerOther)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($answerOther, true), gettype($answerOther)), __LINE__);
        }
        $this->AnswerOther = $answerOther;
        return $this;
    }
    /**
     * Get AnswerExportValue value
     * @return string
     */
    public function getAnswerExportValue()
    {
        return $this->AnswerExportValue;
    }
    /**
     * Set AnswerExportValue value
     * @param string $answerExportValue
     * @return \StructType\Answer
     */
    public function setAnswerExportValue($answerExportValue = null)
    {
        // validation for constraint: string
        if (!is_null($answerExportValue) && !is_string($answerExportValue)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($answerExportValue, true), gettype($answerExportValue)), __LINE__);
        }
        $this->AnswerExportValue = $answerExportValue;
        return $this;
    }
    /**
     * Get AnswerComment value
     * @return string
     */
    public function getAnswerComment()
    {
        return $this->AnswerComment;
    }
    /**
     * Set AnswerComment value
     * @param string $answerComment
     * @return \StructType\Answer
     */
    public function setAnswerComment($answerComment = null)
    {
        // validation for constraint: string
        if (!is_null($answerComment) && !is_string($answerComment)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($answerComment, true), gettype($answerComment)), __LINE__);
        }
        $this->AnswerComment = $answerComment;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Answer
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
