<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreateBudgetItemResult StructType
 * Meta informations extracted from the WSDL
 * - type: s1:CreateBudgetItemResultArray
 * @subpackage Structs
 */
class CreateBudgetItemResult extends AbstractStructBase
{
    /**
     * The Errors
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfError
     */
    public $Errors;
    /**
     * The Id
     * @var string
     */
    public $Id;
    /**
     * The ReferenceId
     * @var string
     */
    public $ReferenceId;
    /**
     * The Success
     * @var bool
     */
    public $Success;
    /**
     * The NewBudgetItem
     * @var bool
     */
    public $NewBudgetItem;
    /**
     * Constructor method for CreateBudgetItemResult
     * @uses CreateBudgetItemResult::setErrors()
     * @uses CreateBudgetItemResult::setId()
     * @uses CreateBudgetItemResult::setReferenceId()
     * @uses CreateBudgetItemResult::setSuccess()
     * @uses CreateBudgetItemResult::setNewBudgetItem()
     * @param \ArrayType\ArrayOfError $errors
     * @param string $id
     * @param string $referenceId
     * @param bool $success
     * @param bool $newBudgetItem
     */
    public function __construct(\ArrayType\ArrayOfError $errors = null, $id = null, $referenceId = null, $success = null, $newBudgetItem = null)
    {
        $this
            ->setErrors($errors)
            ->setId($id)
            ->setReferenceId($referenceId)
            ->setSuccess($success)
            ->setNewBudgetItem($newBudgetItem);
    }
    /**
     * Get Errors value
     * @return \ArrayType\ArrayOfError|null
     */
    public function getErrors()
    {
        return $this->Errors;
    }
    /**
     * Set Errors value
     * @param \ArrayType\ArrayOfError $errors
     * @return \StructType\CreateBudgetItemResult
     */
    public function setErrors(\ArrayType\ArrayOfError $errors = null)
    {
        $this->Errors = $errors;
        return $this;
    }
    /**
     * Get Id value
     * @return string|null
     */
    public function getId()
    {
        return $this->Id;
    }
    /**
     * Set Id value
     * @param string $id
     * @return \StructType\CreateBudgetItemResult
     */
    public function setId($id = null)
    {
        // validation for constraint: string
        if (!is_null($id) && !is_string($id)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id, true), gettype($id)), __LINE__);
        }
        $this->Id = $id;
        return $this;
    }
    /**
     * Get ReferenceId value
     * @return string|null
     */
    public function getReferenceId()
    {
        return $this->ReferenceId;
    }
    /**
     * Set ReferenceId value
     * @param string $referenceId
     * @return \StructType\CreateBudgetItemResult
     */
    public function setReferenceId($referenceId = null)
    {
        // validation for constraint: string
        if (!is_null($referenceId) && !is_string($referenceId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($referenceId, true), gettype($referenceId)), __LINE__);
        }
        $this->ReferenceId = $referenceId;
        return $this;
    }
    /**
     * Get Success value
     * @return bool|null
     */
    public function getSuccess()
    {
        return $this->Success;
    }
    /**
     * Set Success value
     * @param bool $success
     * @return \StructType\CreateBudgetItemResult
     */
    public function setSuccess($success = null)
    {
        // validation for constraint: boolean
        if (!is_null($success) && !is_bool($success)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($success, true), gettype($success)), __LINE__);
        }
        $this->Success = $success;
        return $this;
    }
    /**
     * Get NewBudgetItem value
     * @return bool|null
     */
    public function getNewBudgetItem()
    {
        return $this->NewBudgetItem;
    }
    /**
     * Set NewBudgetItem value
     * @param bool $newBudgetItem
     * @return \StructType\CreateBudgetItemResult
     */
    public function setNewBudgetItem($newBudgetItem = null)
    {
        // validation for constraint: boolean
        if (!is_null($newBudgetItem) && !is_bool($newBudgetItem)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($newBudgetItem, true), gettype($newBudgetItem)), __LINE__);
        }
        $this->NewBudgetItem = $newBudgetItem;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreateBudgetItemResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
