<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DescribeCvObjectResult StructType
 * Meta informations extracted from the WSDL
 * - type: s1:DescribeCvObjectResults
 * @subpackage Structs
 */
class DescribeCvObjectResult extends AbstractStructBase
{
    /**
     * The Field
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Field[]
     */
    public $Field;
    /**
     * The CustomField
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomField[]
     */
    public $CustomField;
    /**
     * The Name
     * @var string
     */
    public $Name;
    /**
     * The Creatable
     * @var bool
     */
    public $Creatable;
    /**
     * The Updateable
     * @var bool
     */
    public $Updateable;
    /**
     * The Deletable
     * @var bool
     */
    public $Deletable;
    /**
     * The Replicateable
     * @var bool
     */
    public $Replicateable;
    /**
     * The Retrieveable
     * @var bool
     */
    public $Retrieveable;
    /**
     * The Searchable
     * @var bool
     */
    public $Searchable;
    /**
     * Constructor method for DescribeCvObjectResult
     * @uses DescribeCvObjectResult::setField()
     * @uses DescribeCvObjectResult::setCustomField()
     * @uses DescribeCvObjectResult::setName()
     * @uses DescribeCvObjectResult::setCreatable()
     * @uses DescribeCvObjectResult::setUpdateable()
     * @uses DescribeCvObjectResult::setDeletable()
     * @uses DescribeCvObjectResult::setReplicateable()
     * @uses DescribeCvObjectResult::setRetrieveable()
     * @uses DescribeCvObjectResult::setSearchable()
     * @param \StructType\Field[] $field
     * @param \StructType\CustomField[] $customField
     * @param string $name
     * @param bool $creatable
     * @param bool $updateable
     * @param bool $deletable
     * @param bool $replicateable
     * @param bool $retrieveable
     * @param bool $searchable
     */
    public function __construct(array $field = array(), array $customField = array(), $name = null, $creatable = null, $updateable = null, $deletable = null, $replicateable = null, $retrieveable = null, $searchable = null)
    {
        $this
            ->setField($field)
            ->setCustomField($customField)
            ->setName($name)
            ->setCreatable($creatable)
            ->setUpdateable($updateable)
            ->setDeletable($deletable)
            ->setReplicateable($replicateable)
            ->setRetrieveable($retrieveable)
            ->setSearchable($searchable);
    }
    /**
     * Get Field value
     * @return \StructType\Field[]|null
     */
    public function getField()
    {
        return $this->Field;
    }
    /**
     * This method is responsible for validating the values passed to the setField method
     * This method is willingly generated in order to preserve the one-line inline validation within the setField method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateFieldForArrayConstraintsFromSetField(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $describeCvObjectResultFieldItem) {
            // validation for constraint: itemType
            if (!$describeCvObjectResultFieldItem instanceof \StructType\Field) {
                $invalidValues[] = is_object($describeCvObjectResultFieldItem) ? get_class($describeCvObjectResultFieldItem) : sprintf('%s(%s)', gettype($describeCvObjectResultFieldItem), var_export($describeCvObjectResultFieldItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Field property can only contain items of type \StructType\Field, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Field value
     * @throws \InvalidArgumentException
     * @param \StructType\Field[] $field
     * @return \StructType\DescribeCvObjectResult
     */
    public function setField(array $field = array())
    {
        // validation for constraint: array
        if ('' !== ($fieldArrayErrorMessage = self::validateFieldForArrayConstraintsFromSetField($field))) {
            throw new \InvalidArgumentException($fieldArrayErrorMessage, __LINE__);
        }
        $this->Field = $field;
        return $this;
    }
    /**
     * Add item to Field value
     * @throws \InvalidArgumentException
     * @param \StructType\Field $item
     * @return \StructType\DescribeCvObjectResult
     */
    public function addToField(\StructType\Field $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Field) {
            throw new \InvalidArgumentException(sprintf('The Field property can only contain items of type \StructType\Field, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Field[] = $item;
        return $this;
    }
    /**
     * Get CustomField value
     * @return \StructType\CustomField[]|null
     */
    public function getCustomField()
    {
        return $this->CustomField;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomField method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomField method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomFieldForArrayConstraintsFromSetCustomField(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $describeCvObjectResultCustomFieldItem) {
            // validation for constraint: itemType
            if (!$describeCvObjectResultCustomFieldItem instanceof \StructType\CustomField) {
                $invalidValues[] = is_object($describeCvObjectResultCustomFieldItem) ? get_class($describeCvObjectResultCustomFieldItem) : sprintf('%s(%s)', gettype($describeCvObjectResultCustomFieldItem), var_export($describeCvObjectResultCustomFieldItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CustomField property can only contain items of type \StructType\CustomField, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CustomField value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomField[] $customField
     * @return \StructType\DescribeCvObjectResult
     */
    public function setCustomField(array $customField = array())
    {
        // validation for constraint: array
        if ('' !== ($customFieldArrayErrorMessage = self::validateCustomFieldForArrayConstraintsFromSetCustomField($customField))) {
            throw new \InvalidArgumentException($customFieldArrayErrorMessage, __LINE__);
        }
        $this->CustomField = $customField;
        return $this;
    }
    /**
     * Add item to CustomField value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomField $item
     * @return \StructType\DescribeCvObjectResult
     */
    public function addToCustomField(\StructType\CustomField $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomField) {
            throw new \InvalidArgumentException(sprintf('The CustomField property can only contain items of type \StructType\CustomField, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CustomField[] = $item;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\DescribeCvObjectResult
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Creatable value
     * @return bool|null
     */
    public function getCreatable()
    {
        return $this->Creatable;
    }
    /**
     * Set Creatable value
     * @param bool $creatable
     * @return \StructType\DescribeCvObjectResult
     */
    public function setCreatable($creatable = null)
    {
        // validation for constraint: boolean
        if (!is_null($creatable) && !is_bool($creatable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($creatable, true), gettype($creatable)), __LINE__);
        }
        $this->Creatable = $creatable;
        return $this;
    }
    /**
     * Get Updateable value
     * @return bool|null
     */
    public function getUpdateable()
    {
        return $this->Updateable;
    }
    /**
     * Set Updateable value
     * @param bool $updateable
     * @return \StructType\DescribeCvObjectResult
     */
    public function setUpdateable($updateable = null)
    {
        // validation for constraint: boolean
        if (!is_null($updateable) && !is_bool($updateable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($updateable, true), gettype($updateable)), __LINE__);
        }
        $this->Updateable = $updateable;
        return $this;
    }
    /**
     * Get Deletable value
     * @return bool|null
     */
    public function getDeletable()
    {
        return $this->Deletable;
    }
    /**
     * Set Deletable value
     * @param bool $deletable
     * @return \StructType\DescribeCvObjectResult
     */
    public function setDeletable($deletable = null)
    {
        // validation for constraint: boolean
        if (!is_null($deletable) && !is_bool($deletable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($deletable, true), gettype($deletable)), __LINE__);
        }
        $this->Deletable = $deletable;
        return $this;
    }
    /**
     * Get Replicateable value
     * @return bool|null
     */
    public function getReplicateable()
    {
        return $this->Replicateable;
    }
    /**
     * Set Replicateable value
     * @param bool $replicateable
     * @return \StructType\DescribeCvObjectResult
     */
    public function setReplicateable($replicateable = null)
    {
        // validation for constraint: boolean
        if (!is_null($replicateable) && !is_bool($replicateable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($replicateable, true), gettype($replicateable)), __LINE__);
        }
        $this->Replicateable = $replicateable;
        return $this;
    }
    /**
     * Get Retrieveable value
     * @return bool|null
     */
    public function getRetrieveable()
    {
        return $this->Retrieveable;
    }
    /**
     * Set Retrieveable value
     * @param bool $retrieveable
     * @return \StructType\DescribeCvObjectResult
     */
    public function setRetrieveable($retrieveable = null)
    {
        // validation for constraint: boolean
        if (!is_null($retrieveable) && !is_bool($retrieveable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($retrieveable, true), gettype($retrieveable)), __LINE__);
        }
        $this->Retrieveable = $retrieveable;
        return $this;
    }
    /**
     * Get Searchable value
     * @return bool|null
     */
    public function getSearchable()
    {
        return $this->Searchable;
    }
    /**
     * Set Searchable value
     * @param bool $searchable
     * @return \StructType\DescribeCvObjectResult
     */
    public function setSearchable($searchable = null)
    {
        // validation for constraint: boolean
        if (!is_null($searchable) && !is_bool($searchable)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($searchable, true), gettype($searchable)), __LINE__);
        }
        $this->Searchable = $searchable;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DescribeCvObjectResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
