<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DescribeCvObjectResults StructType
 * @subpackage Structs
 */
class DescribeCvObjectResults extends AbstractStructBase
{
    /**
     * The DescribeCvObjectResult
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\DescribeCvObjectResult[]
     */
    public $DescribeCvObjectResult;
    /**
     * Constructor method for DescribeCvObjectResults
     * @uses DescribeCvObjectResults::setDescribeCvObjectResult()
     * @param \StructType\DescribeCvObjectResult[] $describeCvObjectResult
     */
    public function __construct(array $describeCvObjectResult = array())
    {
        $this
            ->setDescribeCvObjectResult($describeCvObjectResult);
    }
    /**
     * Get DescribeCvObjectResult value
     * @return \StructType\DescribeCvObjectResult[]|null
     */
    public function getDescribeCvObjectResult()
    {
        return $this->DescribeCvObjectResult;
    }
    /**
     * This method is responsible for validating the values passed to the setDescribeCvObjectResult method
     * This method is willingly generated in order to preserve the one-line inline validation within the setDescribeCvObjectResult method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateDescribeCvObjectResultForArrayConstraintsFromSetDescribeCvObjectResult(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $describeCvObjectResultsDescribeCvObjectResultItem) {
            // validation for constraint: itemType
            if (!$describeCvObjectResultsDescribeCvObjectResultItem instanceof \StructType\DescribeCvObjectResult) {
                $invalidValues[] = is_object($describeCvObjectResultsDescribeCvObjectResultItem) ? get_class($describeCvObjectResultsDescribeCvObjectResultItem) : sprintf('%s(%s)', gettype($describeCvObjectResultsDescribeCvObjectResultItem), var_export($describeCvObjectResultsDescribeCvObjectResultItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The DescribeCvObjectResult property can only contain items of type \StructType\DescribeCvObjectResult, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set DescribeCvObjectResult value
     * @throws \InvalidArgumentException
     * @param \StructType\DescribeCvObjectResult[] $describeCvObjectResult
     * @return \StructType\DescribeCvObjectResults
     */
    public function setDescribeCvObjectResult(array $describeCvObjectResult = array())
    {
        // validation for constraint: array
        if ('' !== ($describeCvObjectResultArrayErrorMessage = self::validateDescribeCvObjectResultForArrayConstraintsFromSetDescribeCvObjectResult($describeCvObjectResult))) {
            throw new \InvalidArgumentException($describeCvObjectResultArrayErrorMessage, __LINE__);
        }
        $this->DescribeCvObjectResult = $describeCvObjectResult;
        return $this;
    }
    /**
     * Add item to DescribeCvObjectResult value
     * @throws \InvalidArgumentException
     * @param \StructType\DescribeCvObjectResult $item
     * @return \StructType\DescribeCvObjectResults
     */
    public function addToDescribeCvObjectResult(\StructType\DescribeCvObjectResult $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DescribeCvObjectResult) {
            throw new \InvalidArgumentException(sprintf('The DescribeCvObjectResult property can only contain items of type \StructType\DescribeCvObjectResult, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->DescribeCvObjectResult[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DescribeCvObjectResults
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
