<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for EventCards StructType
 * @subpackage Structs
 */
class EventCards extends CvObject
{
    /**
     * The ClientDefinedDetail1
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ClientDefinedDetail
     */
    public $ClientDefinedDetail1;
    /**
     * The ClientDefinedDetail2
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\ClientDefinedDetail
     */
    public $ClientDefinedDetail2;
    /**
     * The CardId
     * @var string
     */
    public $CardId;
    /**
     * The CardNumber
     * @var string
     */
    public $CardNumber;
    /**
     * The CardName
     * @var string
     */
    public $CardName;
    /**
     * The EventId
     * @var string
     */
    public $EventId;
    /**
     * The EventCode
     * @var string
     */
    public $EventCode;
    /**
     * The EventTitle
     * @var string
     */
    public $EventTitle;
    /**
     * The Status
     * @var string
     */
    public $Status;
    /**
     * The CurrencyCode
     * @var string
     */
    public $CurrencyCode;
    /**
     * The ApprovedLimit
     * @var string
     */
    public $ApprovedLimit;
    /**
     * The AvailableBalance
     * @var string
     */
    public $AvailableBalance;
    /**
     * The EffectiveDate
     * @var string
     */
    public $EffectiveDate;
    /**
     * The ExpirationDate
     * @var string
     */
    public $ExpirationDate;
    /**
     * The Category
     * @var string
     */
    public $Category;
    /**
     * The CreatedBy
     * @var string
     */
    public $CreatedBy;
    /**
     * The LastModifiedDate
     * @var string
     */
    public $LastModifiedDate;
    /**
     * The LastModifiedBy
     * @var string
     */
    public $LastModifiedBy;
    /**
     * Constructor method for EventCards
     * @uses EventCards::setClientDefinedDetail1()
     * @uses EventCards::setClientDefinedDetail2()
     * @uses EventCards::setCardId()
     * @uses EventCards::setCardNumber()
     * @uses EventCards::setCardName()
     * @uses EventCards::setEventId()
     * @uses EventCards::setEventCode()
     * @uses EventCards::setEventTitle()
     * @uses EventCards::setStatus()
     * @uses EventCards::setCurrencyCode()
     * @uses EventCards::setApprovedLimit()
     * @uses EventCards::setAvailableBalance()
     * @uses EventCards::setEffectiveDate()
     * @uses EventCards::setExpirationDate()
     * @uses EventCards::setCategory()
     * @uses EventCards::setCreatedBy()
     * @uses EventCards::setLastModifiedDate()
     * @uses EventCards::setLastModifiedBy()
     * @param \StructType\ClientDefinedDetail $clientDefinedDetail1
     * @param \StructType\ClientDefinedDetail $clientDefinedDetail2
     * @param string $cardId
     * @param string $cardNumber
     * @param string $cardName
     * @param string $eventId
     * @param string $eventCode
     * @param string $eventTitle
     * @param string $status
     * @param string $currencyCode
     * @param string $approvedLimit
     * @param string $availableBalance
     * @param string $effectiveDate
     * @param string $expirationDate
     * @param string $category
     * @param string $createdBy
     * @param string $lastModifiedDate
     * @param string $lastModifiedBy
     */
    public function __construct(\StructType\ClientDefinedDetail $clientDefinedDetail1 = null, \StructType\ClientDefinedDetail $clientDefinedDetail2 = null, $cardId = null, $cardNumber = null, $cardName = null, $eventId = null, $eventCode = null, $eventTitle = null, $status = null, $currencyCode = null, $approvedLimit = null, $availableBalance = null, $effectiveDate = null, $expirationDate = null, $category = null, $createdBy = null, $lastModifiedDate = null, $lastModifiedBy = null)
    {
        $this
            ->setClientDefinedDetail1($clientDefinedDetail1)
            ->setClientDefinedDetail2($clientDefinedDetail2)
            ->setCardId($cardId)
            ->setCardNumber($cardNumber)
            ->setCardName($cardName)
            ->setEventId($eventId)
            ->setEventCode($eventCode)
            ->setEventTitle($eventTitle)
            ->setStatus($status)
            ->setCurrencyCode($currencyCode)
            ->setApprovedLimit($approvedLimit)
            ->setAvailableBalance($availableBalance)
            ->setEffectiveDate($effectiveDate)
            ->setExpirationDate($expirationDate)
            ->setCategory($category)
            ->setCreatedBy($createdBy)
            ->setLastModifiedDate($lastModifiedDate)
            ->setLastModifiedBy($lastModifiedBy);
    }
    /**
     * Get ClientDefinedDetail1 value
     * @return \StructType\ClientDefinedDetail|null
     */
    public function getClientDefinedDetail1()
    {
        return $this->ClientDefinedDetail1;
    }
    /**
     * Set ClientDefinedDetail1 value
     * @param \StructType\ClientDefinedDetail $clientDefinedDetail1
     * @return \StructType\EventCards
     */
    public function setClientDefinedDetail1(\StructType\ClientDefinedDetail $clientDefinedDetail1 = null)
    {
        $this->ClientDefinedDetail1 = $clientDefinedDetail1;
        return $this;
    }
    /**
     * Get ClientDefinedDetail2 value
     * @return \StructType\ClientDefinedDetail|null
     */
    public function getClientDefinedDetail2()
    {
        return $this->ClientDefinedDetail2;
    }
    /**
     * Set ClientDefinedDetail2 value
     * @param \StructType\ClientDefinedDetail $clientDefinedDetail2
     * @return \StructType\EventCards
     */
    public function setClientDefinedDetail2(\StructType\ClientDefinedDetail $clientDefinedDetail2 = null)
    {
        $this->ClientDefinedDetail2 = $clientDefinedDetail2;
        return $this;
    }
    /**
     * Get CardId value
     * @return string|null
     */
    public function getCardId()
    {
        return $this->CardId;
    }
    /**
     * Set CardId value
     * @param string $cardId
     * @return \StructType\EventCards
     */
    public function setCardId($cardId = null)
    {
        // validation for constraint: string
        if (!is_null($cardId) && !is_string($cardId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cardId, true), gettype($cardId)), __LINE__);
        }
        $this->CardId = $cardId;
        return $this;
    }
    /**
     * Get CardNumber value
     * @return string|null
     */
    public function getCardNumber()
    {
        return $this->CardNumber;
    }
    /**
     * Set CardNumber value
     * @param string $cardNumber
     * @return \StructType\EventCards
     */
    public function setCardNumber($cardNumber = null)
    {
        // validation for constraint: string
        if (!is_null($cardNumber) && !is_string($cardNumber)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cardNumber, true), gettype($cardNumber)), __LINE__);
        }
        $this->CardNumber = $cardNumber;
        return $this;
    }
    /**
     * Get CardName value
     * @return string|null
     */
    public function getCardName()
    {
        return $this->CardName;
    }
    /**
     * Set CardName value
     * @param string $cardName
     * @return \StructType\EventCards
     */
    public function setCardName($cardName = null)
    {
        // validation for constraint: string
        if (!is_null($cardName) && !is_string($cardName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cardName, true), gettype($cardName)), __LINE__);
        }
        $this->CardName = $cardName;
        return $this;
    }
    /**
     * Get EventId value
     * @return string|null
     */
    public function getEventId()
    {
        return $this->EventId;
    }
    /**
     * Set EventId value
     * @param string $eventId
     * @return \StructType\EventCards
     */
    public function setEventId($eventId = null)
    {
        // validation for constraint: string
        if (!is_null($eventId) && !is_string($eventId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eventId, true), gettype($eventId)), __LINE__);
        }
        $this->EventId = $eventId;
        return $this;
    }
    /**
     * Get EventCode value
     * @return string|null
     */
    public function getEventCode()
    {
        return $this->EventCode;
    }
    /**
     * Set EventCode value
     * @param string $eventCode
     * @return \StructType\EventCards
     */
    public function setEventCode($eventCode = null)
    {
        // validation for constraint: string
        if (!is_null($eventCode) && !is_string($eventCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eventCode, true), gettype($eventCode)), __LINE__);
        }
        $this->EventCode = $eventCode;
        return $this;
    }
    /**
     * Get EventTitle value
     * @return string|null
     */
    public function getEventTitle()
    {
        return $this->EventTitle;
    }
    /**
     * Set EventTitle value
     * @param string $eventTitle
     * @return \StructType\EventCards
     */
    public function setEventTitle($eventTitle = null)
    {
        // validation for constraint: string
        if (!is_null($eventTitle) && !is_string($eventTitle)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($eventTitle, true), gettype($eventTitle)), __LINE__);
        }
        $this->EventTitle = $eventTitle;
        return $this;
    }
    /**
     * Get Status value
     * @return string|null
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * Set Status value
     * @param string $status
     * @return \StructType\EventCards
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($status, true), gettype($status)), __LINE__);
        }
        $this->Status = $status;
        return $this;
    }
    /**
     * Get CurrencyCode value
     * @return string|null
     */
    public function getCurrencyCode()
    {
        return $this->CurrencyCode;
    }
    /**
     * Set CurrencyCode value
     * @param string $currencyCode
     * @return \StructType\EventCards
     */
    public function setCurrencyCode($currencyCode = null)
    {
        // validation for constraint: string
        if (!is_null($currencyCode) && !is_string($currencyCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($currencyCode, true), gettype($currencyCode)), __LINE__);
        }
        $this->CurrencyCode = $currencyCode;
        return $this;
    }
    /**
     * Get ApprovedLimit value
     * @return string|null
     */
    public function getApprovedLimit()
    {
        return $this->ApprovedLimit;
    }
    /**
     * Set ApprovedLimit value
     * @param string $approvedLimit
     * @return \StructType\EventCards
     */
    public function setApprovedLimit($approvedLimit = null)
    {
        // validation for constraint: string
        if (!is_null($approvedLimit) && !is_string($approvedLimit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($approvedLimit, true), gettype($approvedLimit)), __LINE__);
        }
        $this->ApprovedLimit = $approvedLimit;
        return $this;
    }
    /**
     * Get AvailableBalance value
     * @return string|null
     */
    public function getAvailableBalance()
    {
        return $this->AvailableBalance;
    }
    /**
     * Set AvailableBalance value
     * @param string $availableBalance
     * @return \StructType\EventCards
     */
    public function setAvailableBalance($availableBalance = null)
    {
        // validation for constraint: string
        if (!is_null($availableBalance) && !is_string($availableBalance)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($availableBalance, true), gettype($availableBalance)), __LINE__);
        }
        $this->AvailableBalance = $availableBalance;
        return $this;
    }
    /**
     * Get EffectiveDate value
     * @return string|null
     */
    public function getEffectiveDate()
    {
        return $this->EffectiveDate;
    }
    /**
     * Set EffectiveDate value
     * @param string $effectiveDate
     * @return \StructType\EventCards
     */
    public function setEffectiveDate($effectiveDate = null)
    {
        // validation for constraint: string
        if (!is_null($effectiveDate) && !is_string($effectiveDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($effectiveDate, true), gettype($effectiveDate)), __LINE__);
        }
        $this->EffectiveDate = $effectiveDate;
        return $this;
    }
    /**
     * Get ExpirationDate value
     * @return string|null
     */
    public function getExpirationDate()
    {
        return $this->ExpirationDate;
    }
    /**
     * Set ExpirationDate value
     * @param string $expirationDate
     * @return \StructType\EventCards
     */
    public function setExpirationDate($expirationDate = null)
    {
        // validation for constraint: string
        if (!is_null($expirationDate) && !is_string($expirationDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($expirationDate, true), gettype($expirationDate)), __LINE__);
        }
        $this->ExpirationDate = $expirationDate;
        return $this;
    }
    /**
     * Get Category value
     * @return string|null
     */
    public function getCategory()
    {
        return $this->Category;
    }
    /**
     * Set Category value
     * @param string $category
     * @return \StructType\EventCards
     */
    public function setCategory($category = null)
    {
        // validation for constraint: string
        if (!is_null($category) && !is_string($category)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($category, true), gettype($category)), __LINE__);
        }
        $this->Category = $category;
        return $this;
    }
    /**
     * Get CreatedBy value
     * @return string|null
     */
    public function getCreatedBy()
    {
        return $this->CreatedBy;
    }
    /**
     * Set CreatedBy value
     * @param string $createdBy
     * @return \StructType\EventCards
     */
    public function setCreatedBy($createdBy = null)
    {
        // validation for constraint: string
        if (!is_null($createdBy) && !is_string($createdBy)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($createdBy, true), gettype($createdBy)), __LINE__);
        }
        $this->CreatedBy = $createdBy;
        return $this;
    }
    /**
     * Get LastModifiedDate value
     * @return string|null
     */
    public function getLastModifiedDate()
    {
        return $this->LastModifiedDate;
    }
    /**
     * Set LastModifiedDate value
     * @param string $lastModifiedDate
     * @return \StructType\EventCards
     */
    public function setLastModifiedDate($lastModifiedDate = null)
    {
        // validation for constraint: string
        if (!is_null($lastModifiedDate) && !is_string($lastModifiedDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastModifiedDate, true), gettype($lastModifiedDate)), __LINE__);
        }
        $this->LastModifiedDate = $lastModifiedDate;
        return $this;
    }
    /**
     * Get LastModifiedBy value
     * @return string|null
     */
    public function getLastModifiedBy()
    {
        return $this->LastModifiedBy;
    }
    /**
     * Set LastModifiedBy value
     * @param string $lastModifiedBy
     * @return \StructType\EventCards
     */
    public function setLastModifiedBy($lastModifiedBy = null)
    {
        // validation for constraint: string
        if (!is_null($lastModifiedBy) && !is_string($lastModifiedBy)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lastModifiedBy, true), gettype($lastModifiedBy)), __LINE__);
        }
        $this->LastModifiedBy = $lastModifiedBy;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\EventCards
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
