<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FieldChoice StructType
 * @subpackage Structs
 */
class FieldChoice extends AbstractStructBase
{
    /**
     * The FieldChoiceText
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FieldChoiceText;
    /**
     * Constructor method for FieldChoice
     * @uses FieldChoice::setFieldChoiceText()
     * @param string $fieldChoiceText
     */
    public function __construct($fieldChoiceText = null)
    {
        $this
            ->setFieldChoiceText($fieldChoiceText);
    }
    /**
     * Get FieldChoiceText value
     * @return string|null
     */
    public function getFieldChoiceText()
    {
        return $this->FieldChoiceText;
    }
    /**
     * Set FieldChoiceText value
     * @param string $fieldChoiceText
     * @return \StructType\FieldChoice
     */
    public function setFieldChoiceText($fieldChoiceText = null)
    {
        // validation for constraint: string
        if (!is_null($fieldChoiceText) && !is_string($fieldChoiceText)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fieldChoiceText, true), gettype($fieldChoiceText)), __LINE__);
        }
        $this->FieldChoiceText = $fieldChoiceText;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FieldChoice
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
