<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProposalSurveyDetail StructType
 * @subpackage Structs
 */
class ProposalSurveyDetail extends RFPQuestionDetail
{
    /**
     * The Answer
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\ProposalAnswer[]
     */
    public $Answer;
    /**
     * Constructor method for ProposalSurveyDetail
     * @uses ProposalSurveyDetail::setAnswer()
     * @param \StructType\ProposalAnswer[] $answer
     */
    public function __construct(array $answer = array())
    {
        $this
            ->setAnswer($answer);
    }
    /**
     * Get Answer value
     * @return \StructType\ProposalAnswer[]|null
     */
    public function getAnswer()
    {
        return $this->Answer;
    }
    /**
     * This method is responsible for validating the values passed to the setAnswer method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAnswer method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAnswerForArrayConstraintsFromSetAnswer(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $proposalSurveyDetailAnswerItem) {
            // validation for constraint: itemType
            if (!$proposalSurveyDetailAnswerItem instanceof \StructType\ProposalAnswer) {
                $invalidValues[] = is_object($proposalSurveyDetailAnswerItem) ? get_class($proposalSurveyDetailAnswerItem) : sprintf('%s(%s)', gettype($proposalSurveyDetailAnswerItem), var_export($proposalSurveyDetailAnswerItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The Answer property can only contain items of type \StructType\ProposalAnswer, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set Answer value
     * @throws \InvalidArgumentException
     * @param \StructType\ProposalAnswer[] $answer
     * @return \StructType\ProposalSurveyDetail
     */
    public function setAnswer(array $answer = array())
    {
        // validation for constraint: array
        if ('' !== ($answerArrayErrorMessage = self::validateAnswerForArrayConstraintsFromSetAnswer($answer))) {
            throw new \InvalidArgumentException($answerArrayErrorMessage, __LINE__);
        }
        $this->Answer = $answer;
        return $this;
    }
    /**
     * Add item to Answer value
     * @throws \InvalidArgumentException
     * @param \StructType\ProposalAnswer $item
     * @return \StructType\ProposalSurveyDetail
     */
    public function addToAnswer(\StructType\ProposalAnswer $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ProposalAnswer) {
            throw new \InvalidArgumentException(sprintf('The Answer property can only contain items of type \StructType\ProposalAnswer, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->Answer[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ProposalSurveyDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
