<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProposalVenueInfo StructType
 * @subpackage Structs
 */
class ProposalVenueInfo extends AbstractStructBase
{
    /**
     * The VenueName
     * @var string
     */
    public $VenueName;
    /**
     * The VenueType
     * @var string
     */
    public $VenueType;
    /**
     * The VenueCode
     * @var string
     */
    public $VenueCode;
    /**
     * The VenueDescription
     * @var string
     */
    public $VenueDescription;
    /**
     * The VenuePhone
     * @var string
     */
    public $VenuePhone;
    /**
     * The VenueAddress1
     * @var string
     */
    public $VenueAddress1;
    /**
     * The VenueAddress2
     * @var string
     */
    public $VenueAddress2;
    /**
     * The VenueCity
     * @var string
     */
    public $VenueCity;
    /**
     * The VenueState
     * @var string
     */
    public $VenueState;
    /**
     * The VenueStateCode
     * @var string
     */
    public $VenueStateCode;
    /**
     * The VenuePostalCode
     * @var string
     */
    public $VenuePostalCode;
    /**
     * The VenueCountry
     * @var string
     */
    public $VenueCountry;
    /**
     * The VenueCountryCode
     * @var string
     */
    public $VenueCountryCode;
    /**
     * The VenueMMA
     * @var string
     */
    public $VenueMMA;
    /**
     * The VenueBrand
     * @var string
     */
    public $VenueBrand;
    /**
     * The VenueChain
     * @var string
     */
    public $VenueChain;
    /**
     * Constructor method for ProposalVenueInfo
     * @uses ProposalVenueInfo::setVenueName()
     * @uses ProposalVenueInfo::setVenueType()
     * @uses ProposalVenueInfo::setVenueCode()
     * @uses ProposalVenueInfo::setVenueDescription()
     * @uses ProposalVenueInfo::setVenuePhone()
     * @uses ProposalVenueInfo::setVenueAddress1()
     * @uses ProposalVenueInfo::setVenueAddress2()
     * @uses ProposalVenueInfo::setVenueCity()
     * @uses ProposalVenueInfo::setVenueState()
     * @uses ProposalVenueInfo::setVenueStateCode()
     * @uses ProposalVenueInfo::setVenuePostalCode()
     * @uses ProposalVenueInfo::setVenueCountry()
     * @uses ProposalVenueInfo::setVenueCountryCode()
     * @uses ProposalVenueInfo::setVenueMMA()
     * @uses ProposalVenueInfo::setVenueBrand()
     * @uses ProposalVenueInfo::setVenueChain()
     * @param string $venueName
     * @param string $venueType
     * @param string $venueCode
     * @param string $venueDescription
     * @param string $venuePhone
     * @param string $venueAddress1
     * @param string $venueAddress2
     * @param string $venueCity
     * @param string $venueState
     * @param string $venueStateCode
     * @param string $venuePostalCode
     * @param string $venueCountry
     * @param string $venueCountryCode
     * @param string $venueMMA
     * @param string $venueBrand
     * @param string $venueChain
     */
    public function __construct($venueName = null, $venueType = null, $venueCode = null, $venueDescription = null, $venuePhone = null, $venueAddress1 = null, $venueAddress2 = null, $venueCity = null, $venueState = null, $venueStateCode = null, $venuePostalCode = null, $venueCountry = null, $venueCountryCode = null, $venueMMA = null, $venueBrand = null, $venueChain = null)
    {
        $this
            ->setVenueName($venueName)
            ->setVenueType($venueType)
            ->setVenueCode($venueCode)
            ->setVenueDescription($venueDescription)
            ->setVenuePhone($venuePhone)
            ->setVenueAddress1($venueAddress1)
            ->setVenueAddress2($venueAddress2)
            ->setVenueCity($venueCity)
            ->setVenueState($venueState)
            ->setVenueStateCode($venueStateCode)
            ->setVenuePostalCode($venuePostalCode)
            ->setVenueCountry($venueCountry)
            ->setVenueCountryCode($venueCountryCode)
            ->setVenueMMA($venueMMA)
            ->setVenueBrand($venueBrand)
            ->setVenueChain($venueChain);
    }
    /**
     * Get VenueName value
     * @return string|null
     */
    public function getVenueName()
    {
        return $this->VenueName;
    }
    /**
     * Set VenueName value
     * @param string $venueName
     * @return \StructType\ProposalVenueInfo
     */
    public function setVenueName($venueName = null)
    {
        // validation for constraint: string
        if (!is_null($venueName) && !is_string($venueName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($venueName, true), gettype($venueName)), __LINE__);
        }
        $this->VenueName = $venueName;
        return $this;
    }
    /**
     * Get VenueType value
     * @return string|null
     */
    public function getVenueType()
    {
        return $this->VenueType;
    }
    /**
     * Set VenueType value
     * @param string $venueType
     * @return \StructType\ProposalVenueInfo
     */
    public function setVenueType($venueType = null)
    {
        // validation for constraint: string
        if (!is_null($venueType) && !is_string($venueType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($venueType, true), gettype($venueType)), __LINE__);
        }
        $this->VenueType = $venueType;
        return $this;
    }
    /**
     * Get VenueCode value
     * @return string|null
     */
    public function getVenueCode()
    {
        return $this->VenueCode;
    }
    /**
     * Set VenueCode value
     * @param string $venueCode
     * @return \StructType\ProposalVenueInfo
     */
    public function setVenueCode($venueCode = null)
    {
        // validation for constraint: string
        if (!is_null($venueCode) && !is_string($venueCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($venueCode, true), gettype($venueCode)), __LINE__);
        }
        $this->VenueCode = $venueCode;
        return $this;
    }
    /**
     * Get VenueDescription value
     * @return string|null
     */
    public function getVenueDescription()
    {
        return $this->VenueDescription;
    }
    /**
     * Set VenueDescription value
     * @param string $venueDescription
     * @return \StructType\ProposalVenueInfo
     */
    public function setVenueDescription($venueDescription = null)
    {
        // validation for constraint: string
        if (!is_null($venueDescription) && !is_string($venueDescription)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($venueDescription, true), gettype($venueDescription)), __LINE__);
        }
        $this->VenueDescription = $venueDescription;
        return $this;
    }
    /**
     * Get VenuePhone value
     * @return string|null
     */
    public function getVenuePhone()
    {
        return $this->VenuePhone;
    }
    /**
     * Set VenuePhone value
     * @param string $venuePhone
     * @return \StructType\ProposalVenueInfo
     */
    public function setVenuePhone($venuePhone = null)
    {
        // validation for constraint: string
        if (!is_null($venuePhone) && !is_string($venuePhone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($venuePhone, true), gettype($venuePhone)), __LINE__);
        }
        $this->VenuePhone = $venuePhone;
        return $this;
    }
    /**
     * Get VenueAddress1 value
     * @return string|null
     */
    public function getVenueAddress1()
    {
        return $this->VenueAddress1;
    }
    /**
     * Set VenueAddress1 value
     * @param string $venueAddress1
     * @return \StructType\ProposalVenueInfo
     */
    public function setVenueAddress1($venueAddress1 = null)
    {
        // validation for constraint: string
        if (!is_null($venueAddress1) && !is_string($venueAddress1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($venueAddress1, true), gettype($venueAddress1)), __LINE__);
        }
        $this->VenueAddress1 = $venueAddress1;
        return $this;
    }
    /**
     * Get VenueAddress2 value
     * @return string|null
     */
    public function getVenueAddress2()
    {
        return $this->VenueAddress2;
    }
    /**
     * Set VenueAddress2 value
     * @param string $venueAddress2
     * @return \StructType\ProposalVenueInfo
     */
    public function setVenueAddress2($venueAddress2 = null)
    {
        // validation for constraint: string
        if (!is_null($venueAddress2) && !is_string($venueAddress2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($venueAddress2, true), gettype($venueAddress2)), __LINE__);
        }
        $this->VenueAddress2 = $venueAddress2;
        return $this;
    }
    /**
     * Get VenueCity value
     * @return string|null
     */
    public function getVenueCity()
    {
        return $this->VenueCity;
    }
    /**
     * Set VenueCity value
     * @param string $venueCity
     * @return \StructType\ProposalVenueInfo
     */
    public function setVenueCity($venueCity = null)
    {
        // validation for constraint: string
        if (!is_null($venueCity) && !is_string($venueCity)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($venueCity, true), gettype($venueCity)), __LINE__);
        }
        $this->VenueCity = $venueCity;
        return $this;
    }
    /**
     * Get VenueState value
     * @return string|null
     */
    public function getVenueState()
    {
        return $this->VenueState;
    }
    /**
     * Set VenueState value
     * @param string $venueState
     * @return \StructType\ProposalVenueInfo
     */
    public function setVenueState($venueState = null)
    {
        // validation for constraint: string
        if (!is_null($venueState) && !is_string($venueState)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($venueState, true), gettype($venueState)), __LINE__);
        }
        $this->VenueState = $venueState;
        return $this;
    }
    /**
     * Get VenueStateCode value
     * @return string|null
     */
    public function getVenueStateCode()
    {
        return $this->VenueStateCode;
    }
    /**
     * Set VenueStateCode value
     * @param string $venueStateCode
     * @return \StructType\ProposalVenueInfo
     */
    public function setVenueStateCode($venueStateCode = null)
    {
        // validation for constraint: string
        if (!is_null($venueStateCode) && !is_string($venueStateCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($venueStateCode, true), gettype($venueStateCode)), __LINE__);
        }
        $this->VenueStateCode = $venueStateCode;
        return $this;
    }
    /**
     * Get VenuePostalCode value
     * @return string|null
     */
    public function getVenuePostalCode()
    {
        return $this->VenuePostalCode;
    }
    /**
     * Set VenuePostalCode value
     * @param string $venuePostalCode
     * @return \StructType\ProposalVenueInfo
     */
    public function setVenuePostalCode($venuePostalCode = null)
    {
        // validation for constraint: string
        if (!is_null($venuePostalCode) && !is_string($venuePostalCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($venuePostalCode, true), gettype($venuePostalCode)), __LINE__);
        }
        $this->VenuePostalCode = $venuePostalCode;
        return $this;
    }
    /**
     * Get VenueCountry value
     * @return string|null
     */
    public function getVenueCountry()
    {
        return $this->VenueCountry;
    }
    /**
     * Set VenueCountry value
     * @param string $venueCountry
     * @return \StructType\ProposalVenueInfo
     */
    public function setVenueCountry($venueCountry = null)
    {
        // validation for constraint: string
        if (!is_null($venueCountry) && !is_string($venueCountry)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($venueCountry, true), gettype($venueCountry)), __LINE__);
        }
        $this->VenueCountry = $venueCountry;
        return $this;
    }
    /**
     * Get VenueCountryCode value
     * @return string|null
     */
    public function getVenueCountryCode()
    {
        return $this->VenueCountryCode;
    }
    /**
     * Set VenueCountryCode value
     * @param string $venueCountryCode
     * @return \StructType\ProposalVenueInfo
     */
    public function setVenueCountryCode($venueCountryCode = null)
    {
        // validation for constraint: string
        if (!is_null($venueCountryCode) && !is_string($venueCountryCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($venueCountryCode, true), gettype($venueCountryCode)), __LINE__);
        }
        $this->VenueCountryCode = $venueCountryCode;
        return $this;
    }
    /**
     * Get VenueMMA value
     * @return string|null
     */
    public function getVenueMMA()
    {
        return $this->VenueMMA;
    }
    /**
     * Set VenueMMA value
     * @param string $venueMMA
     * @return \StructType\ProposalVenueInfo
     */
    public function setVenueMMA($venueMMA = null)
    {
        // validation for constraint: string
        if (!is_null($venueMMA) && !is_string($venueMMA)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($venueMMA, true), gettype($venueMMA)), __LINE__);
        }
        $this->VenueMMA = $venueMMA;
        return $this;
    }
    /**
     * Get VenueBrand value
     * @return string|null
     */
    public function getVenueBrand()
    {
        return $this->VenueBrand;
    }
    /**
     * Set VenueBrand value
     * @param string $venueBrand
     * @return \StructType\ProposalVenueInfo
     */
    public function setVenueBrand($venueBrand = null)
    {
        // validation for constraint: string
        if (!is_null($venueBrand) && !is_string($venueBrand)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($venueBrand, true), gettype($venueBrand)), __LINE__);
        }
        $this->VenueBrand = $venueBrand;
        return $this;
    }
    /**
     * Get VenueChain value
     * @return string|null
     */
    public function getVenueChain()
    {
        return $this->VenueChain;
    }
    /**
     * Set VenueChain value
     * @param string $venueChain
     * @return \StructType\ProposalVenueInfo
     */
    public function setVenueChain($venueChain = null)
    {
        // validation for constraint: string
        if (!is_null($venueChain) && !is_string($venueChain)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($venueChain, true), gettype($venueChain)), __LINE__);
        }
        $this->VenueChain = $venueChain;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ProposalVenueInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
