<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RFPEventInfo StructType
 * @subpackage Structs
 */
class RFPEventInfo extends BaseRFPEventInfo
{
    /**
     * The EventHistoryDetail
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\RFPEventHistoryDetail[]
     */
    public $EventHistoryDetail;
    /**
     * Constructor method for RFPEventInfo
     * @uses RFPEventInfo::setEventHistoryDetail()
     * @param \StructType\RFPEventHistoryDetail[] $eventHistoryDetail
     */
    public function __construct(array $eventHistoryDetail = array())
    {
        $this
            ->setEventHistoryDetail($eventHistoryDetail);
    }
    /**
     * Get EventHistoryDetail value
     * @return \StructType\RFPEventHistoryDetail[]|null
     */
    public function getEventHistoryDetail()
    {
        return $this->EventHistoryDetail;
    }
    /**
     * This method is responsible for validating the values passed to the setEventHistoryDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setEventHistoryDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateEventHistoryDetailForArrayConstraintsFromSetEventHistoryDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $rFPEventInfoEventHistoryDetailItem) {
            // validation for constraint: itemType
            if (!$rFPEventInfoEventHistoryDetailItem instanceof \StructType\RFPEventHistoryDetail) {
                $invalidValues[] = is_object($rFPEventInfoEventHistoryDetailItem) ? get_class($rFPEventInfoEventHistoryDetailItem) : sprintf('%s(%s)', gettype($rFPEventInfoEventHistoryDetailItem), var_export($rFPEventInfoEventHistoryDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The EventHistoryDetail property can only contain items of type \StructType\RFPEventHistoryDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set EventHistoryDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\RFPEventHistoryDetail[] $eventHistoryDetail
     * @return \StructType\RFPEventInfo
     */
    public function setEventHistoryDetail(array $eventHistoryDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($eventHistoryDetailArrayErrorMessage = self::validateEventHistoryDetailForArrayConstraintsFromSetEventHistoryDetail($eventHistoryDetail))) {
            throw new \InvalidArgumentException($eventHistoryDetailArrayErrorMessage, __LINE__);
        }
        $this->EventHistoryDetail = $eventHistoryDetail;
        return $this;
    }
    /**
     * Add item to EventHistoryDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\RFPEventHistoryDetail $item
     * @return \StructType\RFPEventInfo
     */
    public function addToEventHistoryDetail(\StructType\RFPEventHistoryDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RFPEventHistoryDetail) {
            throw new \InvalidArgumentException(sprintf('The EventHistoryDetail property can only contain items of type \StructType\RFPEventHistoryDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->EventHistoryDetail[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RFPEventInfo
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
