<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RetrieveResult StructType
 * Meta informations extracted from the WSDL
 * - type: s1:RetrieveResult
 * @subpackage Structs
 */
class RetrieveResult extends AbstractStructBase
{
    /**
     * The CvObject
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CvObject[]
     */
    public $CvObject;
    /**
     * Constructor method for RetrieveResult
     * @uses RetrieveResult::setCvObject()
     * @param \StructType\CvObject[] $cvObject
     */
    public function __construct(array $cvObject = array())
    {
        $this
            ->setCvObject($cvObject);
    }
    /**
     * Get CvObject value
     * @return \StructType\CvObject[]|null
     */
    public function getCvObject()
    {
        return $this->CvObject;
    }
    /**
     * This method is responsible for validating the values passed to the setCvObject method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCvObject method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCvObjectForArrayConstraintsFromSetCvObject(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $retrieveResultCvObjectItem) {
            // validation for constraint: itemType
            if (!$retrieveResultCvObjectItem instanceof \StructType\CvObject) {
                $invalidValues[] = is_object($retrieveResultCvObjectItem) ? get_class($retrieveResultCvObjectItem) : sprintf('%s(%s)', gettype($retrieveResultCvObjectItem), var_export($retrieveResultCvObjectItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The CvObject property can only contain items of type \StructType\CvObject, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set CvObject value
     * @throws \InvalidArgumentException
     * @param \StructType\CvObject[] $cvObject
     * @return \StructType\RetrieveResult
     */
    public function setCvObject(array $cvObject = array())
    {
        // validation for constraint: array
        if ('' !== ($cvObjectArrayErrorMessage = self::validateCvObjectForArrayConstraintsFromSetCvObject($cvObject))) {
            throw new \InvalidArgumentException($cvObjectArrayErrorMessage, __LINE__);
        }
        $this->CvObject = $cvObject;
        return $this;
    }
    /**
     * Add item to CvObject value
     * @throws \InvalidArgumentException
     * @param \StructType\CvObject $item
     * @return \StructType\RetrieveResult
     */
    public function addToCvObject(\StructType\CvObject $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CvObject) {
            throw new \InvalidArgumentException(sprintf('The CvObject property can only contain items of type \StructType\CvObject, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->CvObject[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\RetrieveResult
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
