<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SupplierExternalIdDetail StructType
 * @subpackage Structs
 */
class SupplierExternalIdDetail extends AbstractStructBase
{
    /**
     * The ExternalIdType
     * @var string
     */
    public $ExternalIdType;
    /**
     * The ExternalId
     * @var string
     */
    public $ExternalId;
    /**
     * Constructor method for SupplierExternalIdDetail
     * @uses SupplierExternalIdDetail::setExternalIdType()
     * @uses SupplierExternalIdDetail::setExternalId()
     * @param string $externalIdType
     * @param string $externalId
     */
    public function __construct($externalIdType = null, $externalId = null)
    {
        $this
            ->setExternalIdType($externalIdType)
            ->setExternalId($externalId);
    }
    /**
     * Get ExternalIdType value
     * @return string|null
     */
    public function getExternalIdType()
    {
        return $this->ExternalIdType;
    }
    /**
     * Set ExternalIdType value
     * @param string $externalIdType
     * @return \StructType\SupplierExternalIdDetail
     */
    public function setExternalIdType($externalIdType = null)
    {
        // validation for constraint: string
        if (!is_null($externalIdType) && !is_string($externalIdType)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalIdType, true), gettype($externalIdType)), __LINE__);
        }
        $this->ExternalIdType = $externalIdType;
        return $this;
    }
    /**
     * Get ExternalId value
     * @return string|null
     */
    public function getExternalId()
    {
        return $this->ExternalId;
    }
    /**
     * Set ExternalId value
     * @param string $externalId
     * @return \StructType\SupplierExternalIdDetail
     */
    public function setExternalId($externalId = null)
    {
        // validation for constraint: string
        if (!is_null($externalId) && !is_string($externalId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($externalId, true), gettype($externalId)), __LINE__);
        }
        $this->ExternalId = $externalId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SupplierExternalIdDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
