<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SupplierRFPForwardHistoryDetail StructType
 * @subpackage Structs
 */
class SupplierRFPForwardHistoryDetail extends AbstractStructBase
{
    /**
     * The SenderFirstName
     * @var string
     */
    public $SenderFirstName;
    /**
     * The SenderLastName
     * @var string
     */
    public $SenderLastName;
    /**
     * The SenderEmailAddress
     * @var string
     */
    public $SenderEmailAddress;
    /**
     * The ForwardedVenueName
     * @var string
     */
    public $ForwardedVenueName;
    /**
     * The ForwardedVenueCode
     * @var string
     */
    public $ForwardedVenueCode;
    /**
     * The ForwardAdditionalInformation
     * @var string
     */
    public $ForwardAdditionalInformation;
    /**
     * The ForwardDate
     * @var string
     */
    public $ForwardDate;
    /**
     * Constructor method for SupplierRFPForwardHistoryDetail
     * @uses SupplierRFPForwardHistoryDetail::setSenderFirstName()
     * @uses SupplierRFPForwardHistoryDetail::setSenderLastName()
     * @uses SupplierRFPForwardHistoryDetail::setSenderEmailAddress()
     * @uses SupplierRFPForwardHistoryDetail::setForwardedVenueName()
     * @uses SupplierRFPForwardHistoryDetail::setForwardedVenueCode()
     * @uses SupplierRFPForwardHistoryDetail::setForwardAdditionalInformation()
     * @uses SupplierRFPForwardHistoryDetail::setForwardDate()
     * @param string $senderFirstName
     * @param string $senderLastName
     * @param string $senderEmailAddress
     * @param string $forwardedVenueName
     * @param string $forwardedVenueCode
     * @param string $forwardAdditionalInformation
     * @param string $forwardDate
     */
    public function __construct($senderFirstName = null, $senderLastName = null, $senderEmailAddress = null, $forwardedVenueName = null, $forwardedVenueCode = null, $forwardAdditionalInformation = null, $forwardDate = null)
    {
        $this
            ->setSenderFirstName($senderFirstName)
            ->setSenderLastName($senderLastName)
            ->setSenderEmailAddress($senderEmailAddress)
            ->setForwardedVenueName($forwardedVenueName)
            ->setForwardedVenueCode($forwardedVenueCode)
            ->setForwardAdditionalInformation($forwardAdditionalInformation)
            ->setForwardDate($forwardDate);
    }
    /**
     * Get SenderFirstName value
     * @return string|null
     */
    public function getSenderFirstName()
    {
        return $this->SenderFirstName;
    }
    /**
     * Set SenderFirstName value
     * @param string $senderFirstName
     * @return \StructType\SupplierRFPForwardHistoryDetail
     */
    public function setSenderFirstName($senderFirstName = null)
    {
        // validation for constraint: string
        if (!is_null($senderFirstName) && !is_string($senderFirstName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($senderFirstName, true), gettype($senderFirstName)), __LINE__);
        }
        $this->SenderFirstName = $senderFirstName;
        return $this;
    }
    /**
     * Get SenderLastName value
     * @return string|null
     */
    public function getSenderLastName()
    {
        return $this->SenderLastName;
    }
    /**
     * Set SenderLastName value
     * @param string $senderLastName
     * @return \StructType\SupplierRFPForwardHistoryDetail
     */
    public function setSenderLastName($senderLastName = null)
    {
        // validation for constraint: string
        if (!is_null($senderLastName) && !is_string($senderLastName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($senderLastName, true), gettype($senderLastName)), __LINE__);
        }
        $this->SenderLastName = $senderLastName;
        return $this;
    }
    /**
     * Get SenderEmailAddress value
     * @return string|null
     */
    public function getSenderEmailAddress()
    {
        return $this->SenderEmailAddress;
    }
    /**
     * Set SenderEmailAddress value
     * @param string $senderEmailAddress
     * @return \StructType\SupplierRFPForwardHistoryDetail
     */
    public function setSenderEmailAddress($senderEmailAddress = null)
    {
        // validation for constraint: string
        if (!is_null($senderEmailAddress) && !is_string($senderEmailAddress)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($senderEmailAddress, true), gettype($senderEmailAddress)), __LINE__);
        }
        $this->SenderEmailAddress = $senderEmailAddress;
        return $this;
    }
    /**
     * Get ForwardedVenueName value
     * @return string|null
     */
    public function getForwardedVenueName()
    {
        return $this->ForwardedVenueName;
    }
    /**
     * Set ForwardedVenueName value
     * @param string $forwardedVenueName
     * @return \StructType\SupplierRFPForwardHistoryDetail
     */
    public function setForwardedVenueName($forwardedVenueName = null)
    {
        // validation for constraint: string
        if (!is_null($forwardedVenueName) && !is_string($forwardedVenueName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($forwardedVenueName, true), gettype($forwardedVenueName)), __LINE__);
        }
        $this->ForwardedVenueName = $forwardedVenueName;
        return $this;
    }
    /**
     * Get ForwardedVenueCode value
     * @return string|null
     */
    public function getForwardedVenueCode()
    {
        return $this->ForwardedVenueCode;
    }
    /**
     * Set ForwardedVenueCode value
     * @param string $forwardedVenueCode
     * @return \StructType\SupplierRFPForwardHistoryDetail
     */
    public function setForwardedVenueCode($forwardedVenueCode = null)
    {
        // validation for constraint: string
        if (!is_null($forwardedVenueCode) && !is_string($forwardedVenueCode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($forwardedVenueCode, true), gettype($forwardedVenueCode)), __LINE__);
        }
        $this->ForwardedVenueCode = $forwardedVenueCode;
        return $this;
    }
    /**
     * Get ForwardAdditionalInformation value
     * @return string|null
     */
    public function getForwardAdditionalInformation()
    {
        return $this->ForwardAdditionalInformation;
    }
    /**
     * Set ForwardAdditionalInformation value
     * @param string $forwardAdditionalInformation
     * @return \StructType\SupplierRFPForwardHistoryDetail
     */
    public function setForwardAdditionalInformation($forwardAdditionalInformation = null)
    {
        // validation for constraint: string
        if (!is_null($forwardAdditionalInformation) && !is_string($forwardAdditionalInformation)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($forwardAdditionalInformation, true), gettype($forwardAdditionalInformation)), __LINE__);
        }
        $this->ForwardAdditionalInformation = $forwardAdditionalInformation;
        return $this;
    }
    /**
     * Get ForwardDate value
     * @return string|null
     */
    public function getForwardDate()
    {
        return $this->ForwardDate;
    }
    /**
     * Set ForwardDate value
     * @param string $forwardDate
     * @return \StructType\SupplierRFPForwardHistoryDetail
     */
    public function setForwardDate($forwardDate = null)
    {
        // validation for constraint: string
        if (!is_null($forwardDate) && !is_string($forwardDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($forwardDate, true), gettype($forwardDate)), __LINE__);
        }
        $this->ForwardDate = $forwardDate;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\SupplierRFPForwardHistoryDetail
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
